#!/usr/local/bin/perl
##############################################################################
# WWWBoard Admin                Version 2.0 ALPHA 2                          #
# Copyright 1996 Matt Wright    mattw@worldwidemart.com                      #
# Created 10/21/95              Last Modified 11/25/95                       #
# Scripts Archive at:           http://www.worldwidemart.com/scripts/        #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1996 Matthew M. Wright  All Rights Reserved.                     #
#                                                                            #
# WWWBoard may be used and modified free of charge by anyone so long as      #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify Matthew M. Wright from any liability that      #  
# might arise from it's use.                                                 #  
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
####################################################################
#
# 1.70a - 25/01/2000 :
# - added locking of main page
# - adapted line matching to new format of main page
# - added threading of messages in 'Remove' and 'Remove by Number'
# - added show_die routine
#
# 1.70b - 30/01/2000 :
# - adapted default passwd_file and logfile
# - added some value cleaning in parse_form
# - removed @referers from configuration
# - included @TOP_BOT in remove summary
# - started cleaning up some of the generated pages
# - added logging of admin errors
#
# 1.70c - 08/02/2000 :
# - added optional logging of admin actions
# - added checking of referrer (for actions only)
# - changed logic for creating date and author pages
# - added check for weird values when removing by date or author
# - adapted parse_form for author names containing weird characters for remove_by_author
#
# 1.70d - 12/02/2000 : (= release version 1.80)
# - adapted parse_form to allow all printable ISO Latin-1 characters
#
# 1.83a - 21/08/2000 :
# - moved $passwd_file and $logfile to $datadir too
#
# TODO :
# - add locking to password file (less urgent)
# - clean up Perl and HTML code some more
# - improve $use_time check to match other time/date formats in 'Remove by Date'
# - remove reference to deleted message from other messages (?)
# - allow multiple users/passwords (?)
# - rethink author name changes in parse_form to avoid overlap between names !
#
####################################################################

# You could copy the whole VARIABLES part from fd_board.cgi if you like,
# but you HAVE to check these specific Admin variables.

    ########################
    # Specific Admin variables
    #

	$admin_url = "http://www.yoursite.com/wwwboard/fd_admin.cgi"; # URL where this fd_admin.cgi script is
	$passwd_file = "my_pass";	# this will go in the $datadir as well

	$showthreads = 1;		# show threads in 'Remove' and 'Remove By Message Number' options

	$log_actions = 1;		# log admin actions - useful if several people are board administrators


##########################################
# VARIABLES - You must edit at least the
# 'File Locations' section to setup board.
#

    ########################
    # File Locations
    #

	$basedir = "/full_path/to/wwwboard";  # real path where your board dir is (your FTP client usually shows the real path)
	$baseurl = "http://www.yoursite.com/wwwboard";  # URL of your board dir
	@referers = ('www.yoursite.com', 'yoursite.com'); # base domain name where your site is

	$datadir = "/full_path/to/data_dir";  # real path where the config files are located (your FTP client usually shows the real path)

	$logfile = "my_log";		# Change this for some privacy !


    # Done! - thats all you *need* to edit. now just chmod everything, (incl. the 'messages'
    # directory) to 777, and the .cgi scripts to 755. then, tweak the stuff below to how you want.
    ###########

	$mesgfile = "index.html";	# It might be better security if you change them,
	$mesgdir = "messages";		# but not really needed.
	$ext = "html";			# Change to "shtml" if you want SSI. If you dont know what Im talking about, leave this as html


    ############################
    # Look / Feel Variables
    #
    # Note : if you have some SSI headers and/or footers (e.g. for banners),
    #        just add them here
    #

	$title = "Discussion Forum";	# Title of the board


	# This html will go at the TOP of every page (all error pages, message posts, etc.)
	# It's regular HTML code that you can cut and paste from an existing page.

	$background = <<'EOBackground';
<!-- start copy & paste background from your index.html -->

 <BODY BGCOLOR="#336699" TEXT="#FFFFFF" LINK="#FFFFFF" VLINK="#C0C0C0" ALINK="#C0C0C0">
 <FONT FACE="arial">

<!-- end copy & paste background from your index.html -->
EOBackground

# don't delete or change the 2 lines that say "EOBackground" - that means no spaces, no tabs, etc. !


	# This html will go at the BOTTOM of every page (all error pages, message posts, etc.)
	# It's regular HTML code that you can cut and paste from an existing page.

	$page_bottom = <<'EOPageBottom';
<!-- start copy & paste page_bottom from your index.html -->

 <BR>
 <SMALL>
 This board is powered by the <A HREF="http://www.cyberarmy.com/search/Programming/Releases/CyberArmy/Mr_Fong_Device">Mr. Fong Device</A> from Cyberarmy.com
 </SMALL>
 <BR>

<!-- end copy & paste page_bottom from your index.html -->
</BODY>
</HTML>
EOPageBottom
# don't delete or change the 2 lines that say "EOPageBottom" - that means no spaces, no tabs, etc. !


    ###################################
    # Security Variables (1=ON, 0=OFF)
    # 

	$log_errors = 1;		# log any script errors - you should leave this ON (and check your logfile from time to time !)
	$log_warnings = 1;		# log any warnings that people receive - this may be useful when you start a new board


    ###################################
    # Standard Variables (1=ON, 0=OFF)
    #

	$use_time = 1;			# Put the time on every post (can be nice)


#
# Nothing (necessary) to edit Past This Point
# A few things for advanced users only.
##############################################

    ###################################
    # System-dependent variables
    #

	$lock_ex = 2; # this should be LOCK_EX from the Fcntl module


###################################
# Main Script
#

# Remove output buffering
$|=1;

# Print out the content-type
print "Content-type: text/html\n\n";

if ($ENV{'QUERY_STRING'} ne '') {
	$command = "$ENV{'QUERY_STRING'}";
}
else {
	&parse_form;
	# Check referrer if you want some action !
	if ($FORM{'action'}) {
		&check_ref;
	}
}

# Main menu of Admin - change if you want
$menu = <<EOT;
 <hr size=7 width=75%>
 <center><font size=-1>
 [ <a href="$admin_url">Admin</a> ]
 [ <a href="$baseurl/$mesgfile">$title</a> ]
 <P>
 [ <a href="$admin_url?remove">Remove by Order</a> ]
 [ <a href="$admin_url?remove_by_date">Remove by Date</a> ]
 [ <a href="$admin_url?remove_by_author">Remove by Author</a> ]
 [ <a href="$admin_url?remove_by_num">Remove by Number</a> ]
 [ <a href="$admin_url?change_passwd">Change Password</a> ]
 </font></center>
 <hr size=7 width=75%>
EOT


###########################################################################
# Remove                                                                  #
#       This option is useful to see how the threads appear in the        #
#   index.html document.  It can give you a better idea of whether or     #
#   not you want to remove the whole thread or just part of it.           #
###########################################################################

if ($command eq 'remove') {
	print <<EOT;
 <html>
 <head>
 	<title>Remove Messages from the $title - by Order</title>
 </head>
 $background
 <center><h2>Remove Messages by Order</h2></center>
 $menu
 <p>
 Select below to remove those postings you wish to remove.
 Choosing the Radio Button on the left will remove the whole thread
 while choosing the Radio Button on the right will remove just that posting.
 <p><p>
 <form method=POST action="$admin_url">
 <input type=hidden name="action" value="remove">
 <input type=hidden name="type" value="remove">
 <center>
 <input type=submit value="Remove"> &nbsp; <input type=reset>
 <p>
 <table border="1" cellpadding="3" cellspacing="0">
 <tr>
  <th colspan=6>
   Username: <input type=text name="username"> &nbsp;&nbsp; Password: <input type=password name="password">
  </th>
 </tr>
 <tr>
  <th>Post # </th><th>Thread </th><th>Single </th><th>Subject </th><th> Author</th><th> Date</th>
 </tr>
EOT

	# open for read/write to allow flock to work on most platforms, even those with lockf(3)
	open(FILE,"+<$basedir/$mesgfile") || show_die("Can't open message file - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock message file - $!\n");
	@lines = <FILE>;
	close(FILE);

	if ($showthreads == 1) {
		$curlevel = 0;
	}
	foreach $line (@lines) {
		if ($line =~ /<!--top: (.*)--><li><a href="$mesgdir\/\1\.$ext">(.*)<\/a>.*- <b>(.*)<\/b>.*<i>(.*)<\/i>/) {
			push(@ENTRIES,$1);
			$SUBJECT{$1} = $2;
			$AUTHOR{$1} = $3;
			$DATE{$1} = $4;
			$level{$1} = $curlevel;
			next;
		}
		if ($showthreads == 1) {
			if ($line =~ /<!--insert: \d+-->/) {
				$curlevel++;
			}
			elsif ($line =~ /<!--end: \d+-->/) {
				$curlevel--;
				if ($curlevel < 0) {
					$curlevel = 0;
				}
			}
		}
	}

	@SORTED_ENTRIES = (sort { $a <=> $b } @ENTRIES);

	foreach (@ENTRIES) {
		print " <tr>\n";
		print "  <th> <b>$_</b> </th><td align=\"center\"> <input type=radio name=\"$_\" value=\"all\"> </td><td align=\"center\"> <input type=radio name=\"$_\" value=\"single\"> </td>";
		if ($showthreads == 1) {
			print "<td> ", '+' x $level{$_} , "<a href=\"$baseurl/$mesgdir/$_\.$ext\">$SUBJECT{$_}</a> </td><td> $AUTHOR{$_} </td><td> $DATE{$_} </td>\n";
		}
		else {
			print "<td> <a href=\"$baseurl/$mesgdir/$_\.$ext\">$SUBJECT{$_}</a> </td><td> $AUTHOR{$_} </td><td> $DATE{$_} </td>\n";
		}
		print " </tr>\n";
	}

	$max = pop(@SORTED_ENTRIES);
	$min = shift(@SORTED_ENTRIES);

	print <<EOT;
 </table>
 <input type=hidden name="min" value="$min">
 <input type=hidden name="max" value="$max">
 <p>
 <input type=submit value="Remove"> &nbsp; <input type=reset>
 </form></center>
 $page_bottom
EOT

	# We stop here
	exit;
}

###########################################################################
# Remove By Number                                                        #
#       This method is useful to see in what order the messages were      #
#   added to the index.html document.                                     #
###########################################################################

elsif ($command eq 'remove_by_num') {
	print <<EOT;
 <html>
 <head>
 	<title>Remove Messages from the $title - by Number</title>
 </head>
 $background
 <center><h2>Remove Messages by Number</h2></center>
 $menu
 <p>
 Select below to remove those postings you wish to remove.
 Choosing the Radio Button on the left will remove the whole thread
 while choosing the Radio Button on the right will remove just that posting.
 <p><p>
 <form method=POST action="$admin_url">
 <input type=hidden name="action" value="remove">
 <input type=hidden name="type" value="remove">
 <center>
 <input type=submit value="Remove"> &nbsp; <input type=reset>
 <p>
 <table border="1" cellpadding="3" cellspacing="0">
 <tr>
  <th colspan=6>
   Username: <input type=text name="username"> &nbsp;&nbsp; Password: <input type=password name="password">
  </th>
 </tr>
 <tr>
  <th>Post # </th><th>Thread </th><th>Single </th><th>Subject </th><th> Author</th><th> Date</th>
 </tr>
EOT

	# open for read/write to allow flock to work on most platforms, even those with lockf(3)
	open(FILE,"+<$basedir/$mesgfile") || show_die("Can't open message file - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock message file - $!\n");
	@lines = <FILE>;
	close(FILE);

	foreach $line (@lines) {
		if ($line =~ /<!--top: (.*)--><li><a href="$mesgdir\/\1\.$ext">(.*)<\/a>.*- <b>(.*)<\/b>.*<i>(.*)<\/i>/) {
			push(@ENTRIES,$1);
			$SUBJECT{$1} = $2;
			$AUTHOR{$1} = $3;
			$DATE{$1} = $4;
			$level{$1} = $curlevel;
			next;
		}
		if ($showthreads == 1) {
			if ($line =~ /<!--insert: \d+-->/) {
				$curlevel++;
			}
			elsif ($line =~ /<!--end: \d+-->/) {
				$curlevel--;
				if ($curlevel < 0) {
					$curlevel = 0;
				}
			}
		}
	}

	@SORTED_ENTRIES = (sort { $a <=> $b } @ENTRIES);

	foreach (@SORTED_ENTRIES) {
		print " <tr>\n";
		print "  <th> <b>$_</b> </th><td align=\"center\"> <input type=radio name=\"$_\" value=\"all\"> </td><td align=\"center\"> <input type=radio name=\"$_\" value=\"single\"> </td>";
		if ($showthreads == 1) {
			print "<td> ", '+' x $level{$_} , "<a href=\"$baseurl/$mesgdir/$_\.$ext\">$SUBJECT{$_}</a> </td><td> $AUTHOR{$_} </td><td> $DATE{$_} </td>\n";
		}
		else {
			print "<td> <a href=\"$baseurl/$mesgdir/$_\.$ext\">$SUBJECT{$_}</a> </td><td> $AUTHOR{$_} </td><td> $DATE{$_} </td>\n";
		}
		print " </tr>\n";
	}

	$max = pop(@SORTED_ENTRIES);
	$min = shift(@SORTED_ENTRIES);

	print <<EOT;
 </table>
 <input type=hidden name="min" value="$min">
 <input type=hidden name="max" value="$max">
 <p>
 <input type=submit value="Remove"> &nbsp; <input type=reset>
 </form></center>
 $page_bottom
EOT

	# We stop here
	exit;
}

###########################################################################
# Remove By Date                                                          #
#       Using this method allows you to delete all messages posted before #
#   a certain date.                                                       #
###########################################################################

elsif ($command eq 'remove_by_date') {
	print <<EOT;
 <html>
 <head>
 	<title>Remove Messages from the $title - by Date</title>
 </head>
 $background
 <center><h2>Remove Messages by Date</h2></center>
 $menu
 <p>
 Select below to remove those postings you wish to remove.
 Checking the Check Box beside a date will remove all postings
 that occurred on that date.
 <p><p>
 <form method=POST action="$admin_url">
 <input type=hidden name="action" value="remove_by_date_or_author">
 <input type=hidden name="type" value="remove_by_date">
 <center>
 <input type=submit value="Remove"> &nbsp; <input type=reset>
 <p>
 <table border="1" cellpadding="3" cellspacing="0">
 <tr>
  <th colspan=4>
   Username: <input type=text name="username"> &nbsp;&nbsp; Password: <input type=password name="password">
  </th>
 </tr>
 <tr>
  <th>X </th><th>Date </th><th># of Messages </th><th>Message Numbers<br></th>
 </tr>
EOT

	# open for read/write to allow flock to work on most platforms, even those with lockf(3)
	open(FILE,"+<$basedir/$mesgfile") || show_die("Can't open message file - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock message file - $!\n");
	@lines = <FILE>;
	close(FILE);

	foreach $line (@lines) {
		if ($line =~ /<!--top: (.*)--><li><a href="$mesgdir\/\1\.$ext">.*<\/a>.*- <b>.*<\/b>.*<i>(.*)<\/i>/) {
			$num = $1;
			$date = $2;
			$day = '';
		# take the last part only - THIS DOESN'T WORK WITH LONG DATES !
			if ($use_time > 0) {
				$day = (split(/\s+/,$date))[-1];
			}
			else {
				$day = $date;
			}
			$DATE{$num} = $day;
			# added a little hash of arrays here
			push(@{$daylist{$day}}, $num);
		}
	}

	# kept the old names, but changed the logic...
	undef(@used_form_values);
	foreach $value (sort keys %daylist) {
		$value_number = 0;
		undef(@values); undef(@short_values);
		foreach $key (sort {$a <=> $b} @{$daylist{$value}}) {
			$key_url = "<a href=\"$baseurl/$mesgdir/$key\.$ext\">$key</a>";
			push(@values,$key_url);
			push(@short_values,$key);
			$value_number++;
		}
		$form_value = $value;
		# this only works for xx/xx/xxxx dates, not for long dates !
		$form_value =~ s/\//_/g;
		print " <tr>\n";
		print "  <td align=\"center\"><input type=checkbox name=\"$form_value\" value=\"@short_values\"> </td><th>$value </th><td align=\"center\">$value_number </td><td>@values<br></td>\n";
		print " </tr>\n";
		push(@used_form_values,$form_value);
	}

	print <<EOT;
 </table>
 <input type=hidden name="used_values" value="@used_form_values">
 <p>
 <input type=submit value="Remove"> &nbsp; <input type=reset>
 </form></center>
 $page_bottom
EOT

	# We stop here
	exit;
}

###########################################################################
# Remove By Author                                                        #
#       This option makes a list of all known authors and then groups     #
#    together there postings and allows you to remove them all at once.   #
###########################################################################

elsif ($command eq 'remove_by_author') {
	print <<EOT;
 <html>
 <head>
 	<title>Remove Messages from the $title - by Author</title>
 </head>
 $background
 <center><h2>Remove Messages by Author</h2></center>
 $menu
 <p>
 Select below to remove those postings you wish to remove.
 Checking the Check Box beside the name of an author will remove all postings
 from that author.
 <p><p>
 <form method=POST action="$admin_url">
 <input type=hidden name="action" value="remove_by_date_or_author">
 <input type=hidden name="type" value="remove_by_author">
 <center>
 <input type=submit value="Remove"> &nbsp; <input type=reset>
 <p>
 <table border="1" cellpadding="3" cellspacing="0">
 <tr>
  <th colspan=4>
   Username: <input type=text name="username"> &nbsp;&nbsp; Password: <input type=password name="password">
  </th>
 </tr>
 <tr>
  <th>X </th><th>Author </th><th># of Messages </th><th>Message #'s<br></th>
 </tr>
EOT

	# open for read/write to allow flock to work on most platforms, even those with lockf(3)
	open(FILE,"+<$basedir/$mesgfile") || show_die("Can't open message file - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock message file - $!\n");
	@lines = <FILE>;
	close(FILE);

	foreach $line (@lines) {
		if ($line =~ /<!--top: (.*)--><li><a href="$mesgdir\/\1\.$ext">.*<\/a>.*- <b>(.*)<\/b>.*<i>.*<\/i>/) {
			$num = $1;
			$auth = $2;
			$AUTHOR{$num} = $auth;
			# added a little hash of arrays here
			push(@{$authlist{$auth}}, $num);
		}
	}

	# kept the old names, but changed the logic...
	undef(@used_form_values);
	foreach $value (sort keys %authlist) {
		$value_number = 0;
		undef(@values); undef(@short_values);
		foreach $key (sort {$a <=> $b} @{$authlist{$value}}) {
			$key_url = "<a href=\"$baseurl/$mesgdir/$key\.$ext\">$key</a>";
			push(@values,$key_url);
			push(@short_values,$key);
			$value_number++;
		}
		$form_value = $value;
		# this may cause trouble with similar names !
		$form_value =~ s/ /_/g;
		print " <tr>\n";
		print "  <td align=\"center\"><input type=checkbox name=\"$form_value\" value=\"@short_values\"> </td><th align=left>$value </th><td align=\"center\">$value_number </td><td>@values<br></td>\n";
		print " </tr>\n";
		push(@used_form_values,$form_value);
	}

	print <<EOT;
 </table>
 <input type=hidden name="used_values" value="@used_form_values">
 <p>
 <input type=submit value="Remove"> &nbsp; <input type=reset>
 </form></center>
 $page_bottom
EOT

	# We stop here
	exit;
}

###########################################################################
# Change Password                                                         #
#       By calling this section of the script, the admin can change his or#
#   her password.							  #
###########################################################################

elsif ($command eq 'change_passwd') {
	print <<EOT;
 <html>
 <head>
 	<title>Change Admin Password for the $title</title>
 </head>
 $background
 <center><h2>Change Admin Password</h2></center>
 $menu
 <p>
 Fill out the form below completely to change your password and user name.
 If new username is left blank, your old one will be assumed.
 <p><p>
 <form method=POST action="$admin_url">
 <input type=hidden name="action" value="change_passwd">
 <center>
 <table border="0">
 <tr>
  <th align=left>Username: </th><td><input type=text name="username"><br></td>
 </tr><tr>
  <th align=left>Password: </th><td><input type=password name="password"><br></td>
 </tr><tr>
  <td colspan=2>&nbsp;</td>
 </tr><tr>
  <th align=left>New Username: </th><td><input type=text name="new_username"><br></td>
 </tr><tr>
  <th align=left>New Password: </th><td><input type=password name="passwd_1"><br></td>
 </tr><tr>
  <th align=left>Re-type New Password: </th><td><input type=password name="passwd_2"><br></td>
 </tr>
 </table>
 <P>
 <input type=submit value="Change"> &nbsp; <input type=reset>
 </center>
 </form>
 $page_bottom
EOT

	# We stop here
	exit;
}

###########################################################################
# Remove Action                                                           #
#       This portion is used by the options remove and remove_by_num.     #
###########################################################################

elsif ($FORM{'action'} eq 'remove') {

	&check_passwd;

	# some checking whether min and max are numerical would be nice, but not essential
	for ($i = $FORM{'min'}; $i <= $FORM{'max'}; $i++) {
		if ($FORM{$i} eq 'all') {
			push(@ALL,$i);
		}
		elsif ($FORM{$i} eq 'single') {
			push(@SINGLE,$i);
		}
	}

	open(FILE,"+<$basedir/$mesgfile") || show_die("Can't open message file - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock message file - $!\n");
	@lines = <FILE>;
	seek(FILE,0,0);

	# clean up the message file first
	# we could reverse the order of the loop later on
	foreach $single (@SINGLE) {
		foreach ($j = 0;$j <= @lines;$j++) {
			if ($lines[$j] =~ /<!--top: $single-->/) {
				splice(@lines, $j, 3);
				$j -= 3;
			}
			elsif ($lines[$j] =~ /<!--end: $single-->/) {
				splice(@lines, $j, 1);
				$j--;
			}
		}
	}

	foreach $all (@ALL) {
		undef($top); undef($bottom);
		foreach ($j = 0;$j <= @lines;$j++) {
			if ($lines[$j] =~ /<!--top: $all-->/) {
				$top = $j;
			}
			elsif ($lines[$j] =~ /<!--end: $all-->/) {
				$bottom = $j;
			}
		}
		if ($top && $bottom) {
			$diff = ($bottom - $top);
			$diff++;
			for ($k = $top;$k <= $bottom;$k++) {
				if ($lines[$k] =~ /<!--top: (.*)-->/) {
					push(@DELETE,$1);
				}
			}
			splice(@lines, $top, $diff);
		}
		else {
			push(@TOP_BOT,$all);
		}
	}

	truncate(FILE,0) || show_die("Can't truncate message file - $!\n");
	print FILE @lines;
	close(FILE);      

	# now try to remove the messages
	foreach $single (@SINGLE) {
		$filename = "$basedir/$mesgdir/$single\.$ext";
		if (-e $filename) {
			unlink("$filename") || push(@NOT_REMOVED,$single);
		}
		else {
			push(@NO_FILE,$single);
		}
		push(@ATTEMPTED,$single);
	}

	foreach $delete (@DELETE) {
		$filename = "$basedir/$mesgdir/$delete\.$ext";
		if (-e $filename) {
			unlink($filename) || push(@NOT_REMOVED,$delete);
		}
		else {
			push(@NO_FILE,$delete);
		}
		push(@ATTEMPTED,$delete);
	}

	&return_html($FORM{'type'});
}

###########################################################################
# Remove Action by Date or Author                                         #
#       This portion is used by the method remove_by_date or 		  #
#   remove_by_author.     		  				  #
###########################################################################

elsif ($FORM{'action'} eq 'remove_by_date_or_author') {

	&check_passwd;

	@used_values = split(/\s/,$FORM{'used_values'});
	foreach $used_value (@used_values) {
		@misc_values = split(/\s/,$FORM{$used_value});
		foreach $misc_value (@misc_values) {
			# avoid weird values
			if ($misc_value =~ /^\d+$/) {
				push(@SINGLE,$misc_value);
			}
		}
	}

	open(FILE,"+<$basedir/$mesgfile") || show_die("Can't open message file - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock message file - $!\n");
	@lines = <FILE>;
	seek(FILE,0,0);

	# clean up the message file first
	# we could reverse the order of the loop later on
	foreach $single (@SINGLE) {
		foreach ($j = 0;$j <= @lines;$j++) {
			if ($lines[$j] =~ /<!--top: $single-->/) {
				splice(@lines, $j, 3);
				$j -= 3;
			}
			elsif ($lines[$j] =~ /<!--end: $single-->/) {
				splice(@lines, $j, 1);
				$j--;
			}
		}
	}

	truncate(FILE,0) || show_die("Can't truncate message file - $!\n");
	print FILE @lines;
	close(FILE);      

	# now try to remove the messages
	foreach $single (@SINGLE) {
		$filename = "$basedir/$mesgdir/$single\.$ext";
		if (-e $filename) {
			unlink("$filename") || push(@NOT_REMOVED,$single);
		}
		else {
			push(@NO_FILE,$single);
		}
		push(@ATTEMPTED,$single);
	}

	&return_html($FORM{'type'});
}

elsif ($FORM{'action'} eq 'change_passwd') {

	&check_passwd;
	# re-using $username and $passwd from there

	if ($FORM{'passwd_1'} ne $FORM{'passwd_2'}) {
		&error('not_same');
	}

	if (length($FORM{'passwd_1'}) < 6) {
		&error('too_short');
	}

	if ($FORM{'new_username'}) {
		$new_username = $FORM{'new_username'};
	}
	else {
		$new_username = $username;
	}

	# using substr($passwd, 0, 2) as salt doesn't work for MD5 passwords
	# (e.g. on VirtualAve), and it's not necessary on other platforms
	$new_password = crypt($FORM{'passwd_1'}, $passwd);

	open(PASSWD,">$datadir/$passwd_file") || &error('no_change');
	print PASSWD "$new_username:$new_password";
	close(PASSWD);

	&return_html('change_passwd');
}

else {
	print <<EOT;
 <html>
 <head>
 	<title>$title Admin</title>
 </head>
 $background
 <center><h2>$title Admin</h2></center>
 $menu
 <p><center>
 <table border="0"><tr><td><font face="arial">
 The following options are available :
 <p>
 <ul>
  <li>Remove Files
   <ul>
    <li><a href="$admin_url?remove">Remove Files by Order</a> (as they appear on the board)
    <li><a href="$admin_url?remove_by_date">Remove Files by Date</a>
    <li><a href="$admin_url?remove_by_author">Remove Files by Author</a>
    <li><a href="$admin_url?remove_by_num">Remove Files by Number</a>
   </ul>
   <br>
  <li>Password
   <ul>
    <li><a href="$admin_url?change_passwd">Change Admin Password</a>
   </ul>
 </ul>
 </td></tr></table></center>
 <P>
 $page_bottom
EOT

	# We stop here
	exit;
}

#######################
# Parse Form Subroutine

sub parse_form {

	# Get the input
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

	# Split the name-value pairs
	@pairs = split(/&/, $buffer);

	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);

		# Un-Webify plus signs and %-encoding
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

		#$value =~ tr/\040-\176//cd;
		# remove all non "ISO Latin-1" (ISO 8859-1) printable characters (including LF)
		$value =~ tr/\040-\176\240-\377//cd;

		# if you want to see < and > here, you'll get them :-)
		$value =~ s/</&lt;/g;
		$value =~ s/>/&gt;/g;

		# change name the same way here - otherwise remove_by_author may not work !
		# Note : there IS a danger of having two authors end up with the same 'name' here
		$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		#$name =~ tr/\040-\176//cd;
		# remove all non "ISO Latin-1" (ISO 8859-1) printable characters (including LF)
		$name =~ tr/\040-\176\240-\377//cd;
		$name =~ s/</&lt;/g;
		$name =~ s/>/&gt;/g;

		$FORM{$name} = $value;
	}

}

sub return_html {
	$type = $_[0];

	if ($type =~ /^remove/) {
		if ($type eq 'remove') {
			$descr = "Results of Message Board Removal by Order";
		}
		elsif ($type eq 'remove_by_date') {
			$descr = "Results of Message Board Removal by Date";
		}
		elsif ($type eq 'remove_by_author') {
			$descr = "Results of Message Board Removal by Author";
		}
		elsif ($type eq 'remove_by_num') {
			$descr = "Results of Message Board Removal by Number";
		}
		else {
			$descr = "Results of Message Board Removal with $type";
			if ($log_errors == 1) {
				log_msg("Admin Script Error : Unknown return_html type '$type'\n");
			}
		}

		print <<EOT;
 <html>
 <head>
 	<title>$descr</title>
 </head>
 $background
 <center><h2>$descr</h2></center>
 $menu
 <p>
 Below is a short summary of what messages were removed from $mesgfile and the
 $mesgdir directory.  All files that the script attempted to remove, were removed,
 unless there is an error message stating otherwise.
 <p><p>
EOT

		$trace = "ACTION : $descr :\n";

		print "<b>Attempted to Remove:</b> @ATTEMPTED<p>\n";
		$trace .= "Files attempted to remove : @ATTEMPTED\n";

		if (@NOT_REMOVED) {
			print "<b>Files That Could Not Be Deleted:</b> @NOT_REMOVED<p>\n";
			$trace .= "Files that could not be deleted : @NOT_REMOVED\n";
		}
		if (@NO_FILE) {
			print "<b>Files Not Found:</b> @NO_FILE<p>\n";
			$trace .= "Files not found : @NO_FILE\n";
		}
		if (@TOP_BOT) {
			print "<b>Files with missing top or bottom tag in main page:</b> @TOP_BOT<p>\n";
			$trace .= "Files with missing top or bottom tag in main page : @TOP_BOT\n";
		}

		print "$page_bottom\n";

		if ($log_actions == 1) {
			log_msg($trace);
		}
	}
	elsif ($type eq 'change_passwd') {
		print <<EOT;
 <html>
 <head>
 	<title>Admin Password Changed</title>
 </head>
 $background
 <center><h2>Admin Password Changed</h2></center>
 $menu
 <p>
 Your Password for $title Admin has been changed ! Results are below :
 <p><p>
 <b>New Username: $new_username<p>
 New Password: $FORM{'passwd_1'}</b><p>
 Do not forget them, since the password is now encrypted in a file and not readable !
 <p>
 $page_bottom
EOT
		if ($log_actions == 1) {
			log_msg("ACTION : Password changed for username $new_username\n");
		}
	}
	else {
		print <<EOT;
 <html>
 <head>
 	<title>Close Encounters of the Third Type ?</title>
 </head>
 $background
 <center><h2>Close Encounters of the Third Type ?</h2></center>
 $menu
 <p><center>
 This is an unknown return_html type '$type'.
 <P>
 Either this script is badly corrupted and needs to be re-installed,
 or you just tried to hack it...
 <p></center>
 $page_bottom
EOT
		if ($log_errors == 1) {
			log_msg("Admin Script Error : Unknown return_html() type '$type'\n");
		}
	}

	# We stop here
	exit;
}

sub error {
	$error = $_[0];

	if ($error eq 'bad_combo') {
		$descr = "Bad Username - Password Combination";
		$message = "You entered an invalid username/password pair. Please try again...";
	}
	elsif ($error eq 'passwd_file') {
		$descr = "Could Not Open Password File For Reading";
		$message = "Check your file permissions and try again...";
	}
	elsif ($error eq 'not_same') {
		$descr = "Different New Passwords";
		$message = "The new passwords you typed in twice were not the same.<P>You may have mistyped - please try again.";
	}
	elsif ($error eq 'too_short') {
		$descr = "New Password is Too Short";
		$message = "The new password you typed in is too short.<P>It should be at least 6 characters long - please try again.";
	}
	elsif ($error eq 'no_change') {
		$descr = "Could Not Open Password File For Writing";
		$message = "The password file could not be changed.<P>Check your file permissions and try again...";

		# this could be by design, so we don't generate an error message
	}
	else {
		$descr = "Welcome to the Twilight Zone...";
		$message = "You just triggered the unknown error '$error'<P>Either this script is badly corrupted and needs to be re-installed, or you just tried to hack it...";

		# this is probably NOT by design, so we generate an error message
		if ($log_errors == 1) {
			log_msg("Admin Script Error : Unknown error() type '$error' for admin action '$FORM{'action'}'\n");
		}
	}

	print <<EOT;
 <html>
 <head>
 	<title>$descr</title>
 </head>
 $background
 <center><h2>$descr</h2></center>
 $menu
 <p><center>
 $message
 </center><p>
 $page_bottom
EOT

	if ($log_warnings == 1) {
		log_msg("WARNING : $descr for admin action '$FORM{'action'}'\n");
	}

	# We stop here
	exit;
}

# no longer used...
#sub passwd_trailer {
#}

sub check_passwd {
	open(PASSWD,"<$datadir/$passwd_file") || &error('passwd_file');
	$passwd_line = <PASSWD>;
	close(PASSWD);

	chomp($passwd_line);
	($username,$passwd) = split(/:/,$passwd_line);

	# using substr($passwd, 0, 2) as salt doesn't work for MD5 passwords
	# (e.g. on VirtualAve), and it's not necessary on other platforms
	$test_passwd = crypt($FORM{'password'}, $passwd);
	if ($FORM{'username'} ne $username || $test_passwd ne $passwd) {
		&error('bad_combo');
	}
}

###################################
# Check referrer (and user agent)
#

sub check_ref {
	# check for authorization
	$requrl = $ENV{'HTTP_REFERER'};
	$flag = 0;

	if ((!$ENV{'HTTP_REFERER'}) || (!$ENV{'HTTP_USER_AGENT'})) {
		$flag=0;
	}
	else {
		foreach $each (@referers){
			if ($requrl =~ /$each/i){
				$flag=1;
				last;
			}
		}
	}
	if ($flag == 1) {
		return;
	}

	print <<EOT;
 <HTML>
 <HEAD>
 	<TITLE>$title Admin - Security Lockout</TITLE>
 </HEAD>
 $background
 <center><H2>$title Admin - Security Lockout</H2></center>
 <br><p>
 This script can only be called from <B>$admin_url</B>, to help prevent people exploiting it.
 For some reason, the script has determined that it was not called from there.
 Occassionaly, it is mistaken. If you are not trying to hack us, you should retype
 the URL in your browser, reload the page, and try again.
 <BR>
 If that still doesn't work, contact the webmaster.
 <P>
 This error and your details have been logged.
 <p>
 <center>[ <a href="$admin_url">Return to the $title Admin</a> ]</center>
 $page_bottom
EOT

	if ($log_warnings == 1) {
		log_msg("WARNING : Admin Security Lockout - wrong referrer '$ENV{'HTTP_REFERER'}' or missing user agent...\n");
	}

	# We stop here
	exit;
}

###################################
# a. Show script error message and die
#

sub show_die {
	my($msg) = @_;

	print <<EOT;
 <HTML>
 <HEAD>
 	<TITLE>$title - ADMIN SCRIPT ERROR</TITLE>
 </HEAD>
 $background
 <CENTER>
 <H2>ADMIN SCRIPT ERROR</H2>
 <HR>
 The following error was encountered while processing your request :
 <P>
 <TABLE BORDER="1" CELLPADDING="5"><TR><TD>
 $msg
 </TD></TR></TABLE>
 <BR>
 <B>Go <a href="$admin_url">back</A> and try again</B>
 <P>
 Note : if this error persists, contact the webmaster.
 <P>
 </CENTER>
 $page_bottom
EOT

	# Log the reason for dying
	if ($log_errors == 1) {
		log_msg("Admin Script Error : $msg");
	}

	# We stop here
	exit;
}


###################################
# b. Log script error messages
#

sub log_msg {
	my($msg) = @_;

	# we can't use show_die() here, of course
	if (open(LOG,">>$datadir/$logfile")) {
		$date = scalar localtime; # no get_time routine here
		print LOG "$date - $ENV{'REMOTE_ADDR'} - $msg";
		close(LOG);
	}
}

