#!/usr/bin/perl
#
#*****************************************************************************
# WARNING - this is a TEST version. It is likely to explode in your face,
# cause a meltdown in a nearby nuclear powerstation or do other nasty things
# like that...
#*****************************************************************************
#
####################################
# IMPROVED WWWBOARD 1.83a Albert Fong Device
# 21 Aug 2000
# 
# This script is an improved version of:
# WWWBoard by Matt Wright (see legal stuff below).
#
# Matt's Script is the web's standard WWWBoard script - used on tens of
# thousands of sites on the Net. It is simple, elegant, and intuitive.
# This script is an update of Matt's WWWBoard, with several major
# improvements :
#
# BUG FIXES:
# Matt's Script was full of bugs (it never went past Alpha 2)
# - *Many* Bugs Fixed. Now, hopefully, bug free!
# 
# SECURITY FIXES:
# Matt's Script paid little attention to security. This board is, basically,
# a 'hackers' fix of the board. It is now immune from all known attacks.
# - All standard attacks plugged (about 5).
# - 6 hypothetical attacks plugged.
# - User Banning Mod Added (ban users IPs)
# - C.Y.R.Y.L Topic Banning Mod Added (ban words, phrases, concepts)
# - Anti-Spam Protection
# - Remote Post Protection Added
# - Board Bombing Fixed (Rootshell Sep'98 Attack)
# - No More Empty Names / Subjects
# - No More Huge Names / Subjects / Posts (size limits)
# - User Logging (Shows IP, ISP, Browser, etc.)
# - Webmaster's Posts Authentication
#
# LOOK / FEEL:
# - Change look of all pages / posts by setting one variable (header/footer).
#
# AUTO CUTTING:
# - Yes! Finally, set the board to the size you want and leave it!
#
#
# NEW IN 1.5:
# - Forms remain filled out (name, email, etc.) thanks to cookies
# - better looking 'post' box
# - Anti-'test' message filter
# - anti-spam bug fix
# - better protection against some remote attacks & javascript attacks
# - improved anti-lameness filters (for hacker boards)
# - board attempts to auto-refresh (some browsers)
#
# 1.53:
# - a y2k fix
# - flock protection (file locking prevents overloading)
#
# *** Questions / Bug Reports should go to www.cyberarmy.com/wwwboard
#
# 1.60:
# This is a BIG quick rewrite to fix board bombing which is happening
# everywhere now. A UK teenager called Peter ******* (viruspete) has found a
# stupid vulnerability in almost all wwwboard scripts which destroys them, and
# then destroyed 50 or so boards including older Albert Fong script boards.
# The sploit is because on Linux / Perl machines, flock() doesnt seem to work
# instantly, or even near instantly. The fix is pretty complicated, but it
# seems to work okay. Stay tuned for a follow up version 1.61, which should
# have an autorepair mod which can repair any damage done to any boards.
# 
# ALSO - Some extra new BIG mods:
# * AUTOBANNING!! mod. you can add a file with words / phrases / names which
# result in an autoban. The users IP _and_ browser are banned. (Yes, it uses
# some VERY effective ban techniques now). Put words / names into the file
# autoban.txt some people who are clearly attacking the board (board bombing,
# posting thru scripts) are also immediately autobanned.
# * DES Signatures. Users now get a DES signature when they post.
# * heaps of minor (inluding y2k) fixes
#
# 1.70a - 25/01/2000 (full code review by TheGame)
# - File access and locking reviewed
# - your_ip vanity code added again
# - Look & feel variables used in all messages again
# - WWWBoard Bomb Patch code cleaned up
# - Some dead code removed
# - no_spam code reviewed
# - Configurable logfile added
# - Script errors are logged by default
# - Split check_url into get_host and check_url
# - Added use_DES option
# - etc.
#
# 1.70b - 30/01/2000 (some fixes)
# - cleaned up host lookup bug (found by Freddy G.)
# - cleaned up HTML sploit in USER_AGENT (found by complex)
# - cleaned up non-printable HTML char sploit (found by complex & TW)
# - cleaned up non-space blanks sploit in subject, name etc.
# - fixed bugs in length abuse mod + added checks for other fields
# - adapted max length of some fields
# - adapted form code and form in index.html to match max lengths
# - changed default max number of messages to 9999
# - renamed default logfile (and password file in fd_admin.cgi)
# - print content-type at beginning of script to avoid doubles with show_die
# - added $buffer to full logging, to see what was really sent
#
# 1.70c - 08/02/2000 (some more fixes)
# (thanks to complex, TW, psyber, Overlord, stigmata etc for all those tests)
# - removed max number of messages and added max_archive
# - cleaned up parse_form and get_variables a bit more
#   (still highly insecure with allow_html=1)
# - removed misleading allow_xyz options
# - added size limit to logging of $buffer
# - full logging option only keeps "interesting" environment variables now
# - added default logging of banned and warned posters
# - added AM/PM format for $date
# - added cookie checking in check_magic
# - added ban_time option and changed check_ip routine
# - improved no_spam routine and changed file format
# - added double gethostbyaddr for timeout problems
# - fixed dangerous bug in WWWBoard Bomb Patch
# - fixed quote-name bug (found by stigmata)
# - added some code to reduce (not eliminate !) risks of messing up form
#   with allow_html=1
# - changed magic number generation to reduce faking and DoS
# - added show_respnum option to show or hide number of "responses"
# - renamed more files to make people change their names at installation.
#   At least, they will if they're not clueless newbies :-)
# - added proxy ban mod from complex et al.
#
# 1.70d - 12/02/2000 (= release version 1.80)
# (thanks to everyone for tests, suggestions, mods, etc.)
# - changed parse_form again to allow the whole printable ISO Latin-1 charset
# - changed filtering of HTML tags etc.
# - now sending real cookies instead of the JavaScript stuff
# - fixed magic cookie bug
# - moved no_spam AFTER get_variables to 'allow' people to send empty names by
#   mistake without being hit by the no_spam rule
# - changed banning into warning for missing HTTP headers
# - changed some layout stuff (AM/PM, DES at the end, etc.)
# - added lynx to recognized *nix systems (not activated)
# - changed no_test test to allow subject like 'latest ...'
# - reorganised proxy mod for better distinction between detection and banning
# - renamed to 1.80 to avoid confusion with older test versions :)
#
# 1.80 Release Version of 1.70d
#
# 1.81 - small fixes re: beta proxy mod
#
# 1.82 - 12/06/2000 (TheGame)
# - added rank mod to replace Cyberarmy-specific code
# - added database authentication mod
# - moved all files except main page and messages to $datadir
#   (watch out with data.txt, overload1 etc. if you have multiple boards !)
# - added allow_civilians option (their name is the DES sig for the moment)
# - 'slightly' adapted DES sig generation :)
#
# 1.83a - 21/08/2000 (TheGame) - test version a
# - updated proxy mod based on the experience of complex's proxy test board
# - switched to file-based user authentication to make it a bit more portable
# - added fd_user script for basic user administration
#
# TODO : add support scripts for rank attribution, banning etc.
#
#
# POSSIBLE FUTURE MODS :
# - add DES sig as authentication for boardmaster
# - filter out onload() etc. events for allow_html ON
# - split 'origname' field back into 'origname' and 'origenviron'
# - solve bug of replies to messages that were autocut
#   (e.g. add a <!--end--> in index.html and place message before that)
# - improve proxy ban mod from complex et al.
# - improve speed of multiple topicban, autoban and HTML filter regexes
# - clean up HTML and JavaScript
# - review overload protection
# - investigate 'autorepair' feature
# - try using temp file for updating of main page ?
#   (Not sure about that one - renaming of flocked open
#   filehandles seems like a tricky business...)
#
#################################
# LEGAL STUFF -
#
# Version 1.70/1.83 was compiled by TheGame (jointhegame@crosswinds.net).
# The rules below also apply for this version...
#
# This improvement was compiled by www.cyberarmy.com. As far as I'm concerned,
# this board is fully open source and free. Main contributors are first, Matt
# Wright, who did the base script. Matt's Script was extensively hacked by Ken
# Williams (packetstorm@genocide2600.com) then by Samuel Sparling (Epicurus).
# Then all the improvements, and other mods were added and polished by
# webmaster@cyberarmy.com. Improve it! Distribute it!
# You may not charge for it, or remove these comments. As requested, the
# original legal stuff by Matt Wright remains below:
#
##############################################################################
# WWWBoard                      Version 2.0 ALPHA                            #
# Copyright 1996 Matt Wright    mattw@worldwidemart.com                      #
# Created 10/21/95              Last Modified 11/25/95                       #
# Scripts Archive at:           http://www.worldwidemart.com/scripts/        #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1996 Matthew M. Wright  All Rights Reserved.                     #
#                                                                            #
# WWWBoard may be used and modified free of charge by anyone so long as      #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify Matthew M. Wright from any liability that      #  
# might arise from it's use.                                                 #  
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################


##########################################
# VARIABLES - You must edit at least the
# 'File Locations' section to setup board.
#

    ########################
    # File Locations
    #

	$basedir = "/full_path/to/wwwboard";  # real path where your board dir is (your FTP client usually shows the real path)
	$baseurl = "http://www.yoursite.com/wwwboard";  # URL of your board dir
	@referers = ('www.yoursite.com', 'yoursite.com'); # base domain name where your site is

	$datadir = "/full_path/to/data_dir";  # real path where the config files are located (your FTP client usually shows the real path)

	$logfile = "my_log";		# Change these for some privacy !
	$no_spam_file = "my_spam";	# NOTE: You _should_ also change the name of the
	$ip_file = "my_ban";		# default password file in the fd_admin.cgi script

	$cgi_url = "http://www.yoursite.com/wwwboard/fd_board.cgi"; # URL where this (yes! this very) cgi script is :)

	$dessalt = '3a';		# choose two random alphanumerics. Used as DES salt.


    # Done! - thats all you *need* to edit. now just chmod everything, (incl. the 'messages'
    # directory) to 777, and the .cgi scripts to 755. then, tweak the stuff below to how you want.
    ###########

	$mesgfile = "index.html";	# It might be better security if you change them,
	$mesgdir = "messages";		# but not really needed.
	$ext = "html";			# Change to "shtml" if you want SSI. If you dont know what Im talking about, leave this as html

	$faqfile = "faq.html";		# faq2.html is a hackers faq

# Watch out with multiple boards : use different $datafile's !!!!
	$datafile = "data.txt";		# You _can_ leave this all as is, if you use a separate datadir.
	$topicban_file = "topicban.txt";# Otherwise, people may be able to see the forbidden topics and go around them
	$autoban_file = "autoban.txt";	#


    ############################
    # Look / Feel Variables
    #
    # Note : if you have some SSI headers and/or footers (e.g. for banners),
    #        just add them here
    #

	$title = "Discussion Forum";	# Title of the board

	# This html will go at the TOP of every page (all error pages, message posts, etc.)
	# It's regular HTML code that you can cut and paste from an existing page.

	$background = <<'EOBackground';
<!-- start copy & paste background from your index.html -->

 <BODY BGCOLOR="#336699" TEXT="#FFFFFF" LINK="#FFFFFF" VLINK="#C0C0C0" ALINK="#C0C0C0">
 <FONT FACE="arial">

<!-- end copy & paste background from your index.html -->
EOBackground

# don't delete or change the 2 lines that say "EOBackground" - that means no spaces, no tabs, etc. !

	# This html will go at the BOTTOM of every page (all error pages, message posts, etc.)
	# It's regular HTML code that you can cut and paste from an existing page.

	$page_bottom = <<'EOPageBottom';
<!-- start copy & paste page_bottom from your index.html -->

 <BR>
 <SMALL>
 This board is powered by the <A HREF="http://www.cyberarmy.com/search/Programming/Releases/CyberArmy/Mr_Fong_Device">Mr. Fong Device</A> from Cyberarmy.com
 </SMALL>
 <BR>

<!-- end copy & paste page_bottom from your index.html -->
</BODY>
</HTML>
EOPageBottom
# don't delete or change the 2 lines that say "EOPageBottom" - that means no spaces, no tabs, etc. !


	$contact = '';			# put your e-mail address here if you want it to show as a mailto: link in error messages
					# example : $contact = 'webmaster@cyberarmy.com';


    ###################################
    # Security Variables (1=ON, 0=OFF)
    # 

	$log_errors = 1;		# log any script errors - you should leave this ON (and check your logfile from time to time !)
	$log_warnings = 1;		# log any warnings that people receive - this may be useful when you start a new board
	$log_banned = 1;		# log banned users - this may be useful in general
	$log_users = 0;			# if the board is under attack, switch this on - it keeps a complete record of who's sending what

	$environment_lock = 1;		# activate get_env protection (stop 90% of external form input)
					# => only issues a warning, depending on what's wrong

	$stop_spam = 1;			# activate anti-spam protection (continual posting of the same message)
	$spam_time = 45;		# if stop_spam is on, time limit on reposting (in SECONDS)

	$topic_ban = 1;			# activate topic banning (words, phrases listed in $topicban_file)
					# => only issues a warning

	$user_ban = 1;			# activate IP banning (users listed in $ip_file)
	$ban_time = 3 * 24 * 3600;	# if $user_ban is on, time limit before banning is cleared (in SECONDS)
					# (-1 means the user is banned forever...)
	$autoban = 1;			# activate auto banning (words, phrases listed in $autoban_file)
					# => bans the poster

	$cut_fields = 1;		# activate length abuse protection
	$max_subject = 45;		#
	$max_name = 25;			# If cut_fields is on, the length to cut
	$max_body = 30000;		# subject input to, etc.
	$max_url = 120;			#
	$max_url_title = 80;		# Leave reasonable limits on all sections to stop
	$max_email = 80;		# people posting 10 MB messages, etc.
	$max_img = 120;			# IF YOU CHANGE THIS, DON'T FORGET TO CHANGE THE FORM IN INDEX.HTML TOO !

	$no_tests = 1;			# stop 'test' messages

	# future mod : include DES sig as authentication
	$your_ip = "127.0.0.1";		# for boardmaster authentication, put your usual IP here (if it's static, at least)

	$use_DES = 0;			# use DES signature to authenticate posters (can be replaced with DB authentication)


    ######################################
    # AutoCutting Variables (1=ON, 0=OFF)
    #

	$auto_cut = 1;			# AutoCut the board when it gets to a certain size.
	$max_posts = 200;		# Cut at this size. (ie, 100=small, 200=medium, 300=big)
	$max_archive = 500;		# Maximum number of messages kept (always higher than $max_posts !)


    ###################################
    # Standard Variables (1=ON, 0=OFF)
    #

	$use_time = 5;			# Put the time on every post (can be nice)
					# Note : several formats are available in the code below
	$show_faq = 1;			# Show a 'FAQ' link for every message (a bit useless)
	$quote_text = 1;		# In replies, leave the previous message
	$subject_line = 0;		# This means :	0 = Quote Subject, Editable (= normal setting)
					# 		1 = Quote Subject, UnEditable
					# 		2 = Don't Quote Subject, Editable
	$show_respnum = 0;		# Show number of 'responses' (replies) to a message

	# WARNING : the following option can be dangerous to the health of your board !
	# Only a limited number of HTML sploits are intercepted here...

	$allow_html = 0;		# Suggest leave this off for security reasons.


	# Note about character sets :
	#
	# If your posters usually work with a non "Latin-1" charset,
	# like Japanese, Arabic etc., you need to change the allowed
	# range of characters in parse_form.
	# Otherwise, people will be able to use subjects and names that
	# appear to be empty - not very nice for your board...
	# And you will also need to adapt fd_admin.cgi in the same way.


    ######################################
    # Rank Mod. Variables
    #

	$use_rank = 1;		# use title/badge to indicate rank

	# list of available ranks (from HIGH to LOW !!!)
	@ranklist = ('r5','r4','r3','r2','r1');

	# name to be used for each rank (used inside the messages)
	%rankname = (
		r1	=>	'Rank I',
		r2	=>	'Rank II',
		r3	=>	'Rank III',
		r4	=>	'Rank IV',
		r5	=>	'Rank V',
	);

	# title to be used for each rank (used on the main board)
	%ranktitle = (
		r1	=>	'R1.',
		r2	=>	'R2.',
		r3	=>	'R3.',
		r4	=>	'R4.',
		r5	=>	'R5.',
	);

	# badge to be used for each rank (use relative or absolute URL here)
	%rankbadge = (
		r1	=>	"$baseurl/1star.gif",
		r2	=>	"$baseurl/2star.gif",
		r3	=>	"$baseurl/3star.gif",
		r4	=>	"$baseurl/4star.gif",
		r5	=>	"$baseurl/5star.gif",
	);

	$badgewidth = 15;	# width of the badge (on main board)
	$badgeheight = 15;	# height of the badge (on main board)

	$rankhighlight = 1;	# highlight posts from top 2 ranks (start counting at 0)

	# code used in the 'rcode' cookie to identify the rank (can be replaced by DB authentication)
	%rankcode = (
		'1rank' =>	'r1',
		'ranked2' =>	'r2',
		'rankm3' =>	'r3',
		'r4nks' =>	'r4',
		'rankin5' =>	'r5',
	);

	$show_unix = 1;		# check if the poster uses a Unix/Linux system
	$unixbadge = "$baseurl/nix.gif"; # use relative or absolute URL here

	$allow_civilians = 1;	# allow non-ranked/non-registered people to post as well
	$civiliantitle = 'Civ.';	# title to be used for civilians (used on the main board)


    ###################################
    # For expert users only - ONLY IF YOU RUN THIS ON YOUR own SERVER(S) !
    #
    # (for a full description, see the code at the bottom of the script)
    #

	######################################
	# Database Authentication Mod. Variables
	#
	# (requires additional scripts for user registration etc.)
	#

	$use_dbauth = 1;	# use database authentication

	# KEEP THIS OUTSIDE THE WEB-ACCESSIBLE PART OF YOUR SERVER !!!
	$user_db = "$datadir/user_db";	# location of user database


	###################################
	# Anti-Overload Mod.2beta (cyberarmy)
	#

	$limit_load = 0;		# 1 = overload1 : number of (almost) concurrent requests
					# 2 = overload2 : time since last request
	$max_load1 = 2;			# maximum number of (almost) concurrent requests allowed
	$max_load2 = 5;			# minimum time between starting requests (in seconds)


	###################################
	# Anonymous Proxy Ban version B52 (complex)
	#

	$detect_proxy = 0;		# try to detect if a proxy is used (= activates the proxy mod !)

	$proxy_file = "my_proxies";	# list of banned proxies

	$check_proxy_env = 1;		# check for proxy in environment
	$ban_proxy_env = 0;		# ban most proxies right away (NOT recommended !)

	$check_proxy_file = 1;		# check for proxy in proxy_file
	$ban_proxy_file = 1;		# ban proxies in proxy_file

	$check_proxy_anon = 1;		# check for anonymous proxy (and add to proxy_file)
	$ban_proxy_anon = 0;		# ban anonymous proxies

	$check_ping = 0;		# check that forwarded IP addresses exist (if ban_proxy_anon is ON) - doesn't work for hosts behind firewalls !
	$check_cookie = 1;		# check that cookies are sent (if ban_proxy_anon is ON) - cookies & Javascript must be enabled for this !

#
# Nothing (necessary) to edit Past This Point
# A few things for advanced users only.
##############################################


#######################################################################
#                                                                     #
# Warning to Perl programmers and would-be code copiers :             #
#                                                                     #
# The following script does NOT represent a good way of programming   #
# in Perl - do not use it as an example on how to do Perl/CGI stuff ! #
#                                                                     #
#######################################################################

    ###################################
    # System-dependent variables
    #

	$addr_type = 2; # this should be AF_INET from the Socket module
	$lock_ex = 2; # this should be LOCK_EX from the Fcntl module

	# Define what to show in case of errors
	if ($contact) {
		$webmaster = "<A HREF=\"mailto:$contact\">webmaster</A>";
	}
	else {
		$webmaster = "webmaster";
	}


###################################
# Main Script
#

# Remove output buffering
	$|=1;

# Print out the content-type (replaced because of cookies)
#	print "Content-type: text/html\n\n";
# Make sure we print content-type only once
	$http_printed = 0;

   # Set Overload Protection - expert users only
	if ($limit_load > 0) {
		&check_load;
	}

# (1) Get form information
	&parse_form;

# (2) Get current time (change the date & time format there if you want)
	&get_time;

# (3) Log the poster here (change what is logged there if you want)
	if ($log_users == 1)
	{
		&log;
	}

# (4) Check referring URL etc. - remote post security fix
	if ($environment_lock == 1)
	{
		&check_url;
	}

# (7) Get host information (change the environment format there if you want)
#     + add special domain bans (e.g. AOL :) if you want
	&get_host;

	if ($user_ban == 1)
	{
# (5) Check magic ban
		&check_magic;
# (6) Check IP ban
		&check_ip;
	}

# Some additional custom bans (if you want to hard-code this) :
#	if ($FORM{'name'} =~ /ban this name/i) {
#		&error('ban_user');
#	}

# (8) Put items into nice variables (no_tests is checked here too)
# TODO - some logic problem with adapted check_ip()
	&get_variables;

# Get user info from database --> $rank can only be used after this
	if ($use_dbauth == 1) {
		&get_user;
	}

# (9) Stop spam (moved here to allow empty name errors etc.)
	if ($stop_spam == 1) {
	# only stop spam for lower ranks (and civilians)
	#	unless ($rank eq 'r5' || $rank eq 'r4') {
			&no_spam;
	#	}
	}

# (10) Check for automatic ban words (=> bans the poster)
	if ($user_ban == 1 && $autoban == 1) {
		&check_autoban;
	}

# (11) Check for banned words (=> only issues a warning)
	if ($topic_ban == 1) {
	# only stop spam for lower ranks (and civilians)
	#	unless ($rank eq 'r5' || $rank eq 'r4') {
			&topicban;
	#	}
	}

   # Anonymous Proxy Ban - expert users only (beta)
	if ($detect_proxy == 1) {
		&do_proxy_mod;
	}

# Some rank-specific changes :
	if ($use_rank == 1) {
		if ($rank eq 'r5') { $environ = "[Boardmaster]"};
		if ($rank eq 'r4') { $environ = "(host withheld)"};
	}

# All the checks are done here, so we save the new message.
# If you want to add some more checks, put them above this.

# (12) Get the data number
	&get_number;

# (13) Open the new file and write information to it.
	&new_file;

# (14) Open the main WWWBoard file to add link
	&main_page;

# (15) Now add thread to individual pages
	if ($num_followups >= 1) {
		&thread_pages;
	}

# (16) Return the user HTML
	&return_html;

   # Clear Overload Protection - expert users only
	if ($limit_load > 0) {
		&clear_load;
	}

# That's all, folks !
	exit;

#
# End of Main Script
###################################


###################################
# 1. Parse Form Subroutine
#
# (don't copy this - use CGI.pm instead)
#

sub parse_form {
	# read $buffer and $ENV{CONTENT_LENGTH} from STDIN (Standard Input)
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); 
	# if the buffer is shorter less than 5 chars
	if(length($buffer) < 5)
	{
		# the buffer is the query string
		# Note : this shouldn't be allowed...
		$buffer = $ENV{'QUERY_STRING'};
	}

	# split $buffer at the & symbols and put into @pairs array
	@pairs = split(/&/, $buffer);

	# for every element in the @pairs array
	foreach $pair (@pairs)
	{
		# split into parts
		($name, $value) = split(/=/, $pair);
		# change +'s to spaces
		$value =~ tr/+/ /;
		# UN-URL-encode input
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

		# The following two rules may be a bit too harsh for the
		# 'body', so we make an exception.
		# This may change in the future...
		unless ($name eq 'body') {
			# remove all non "plain ASCII" characters (including LF)
			# sploit found by complex and TW
			#$value =~ tr/\040-\176//cd;
		# CHANGE THIS IF YOU USE A DIFFERENT CHARSET, LIKE JAPANSE OR ARABIC !
			# remove all non "ISO Latin-1" (ISO 8859-1) printable characters (including LF)
			$value =~ tr/\040-\176\240-\377//cd;
		}

		# &amp; is allowed in URLs, so we only exclude body here...
		# too bad for the few 'interesting' symbols like trademark
		unless ($name eq 'body' && $allow_html == 1) {
			# disable all HTML 'character references'
			# sploit found by complex and TW
			$value =~ s/\&/&amp;/g;

			# take care of quotes
			# see get_variables too !
			$value =~ s/"/&quot;/g;
		}

		if ($name eq 'body' && $allow_html == 1) {
			# take out SSI/Comment tags (always)
			# Non-greedy now : *? instead of *
			#$value =~ s/<!--((.|\n)*?)-->/&lt;!--$1--&gt;/g;
			# + also filter out SGML comments now
			$value =~ s/<!((.|\n)*?)-->/&lt;!$1--&gt;/g;
			# take out begin SSI/Comment tags
			#$value =~ s/<!--((.|\n)*)/&lt;!--$1/g;
			$value =~ s/<!((.|\n)*)/&lt;!$1/g;
			# take out end SSI/Comment tags
			$value =~ s/((.|\n)*)-->/$1--&gt;/g;
		}

		# change pipes to their HTML-ASCII equivilent (&#124),
		# because the datafile uses pipes (what ?)
		$value =~ s/\|/\&#124;/g;

	# Note that we don't escape any other shell metacharacter here !
	# Don't use ANY value directly in system(), exec(), open(), `` etc.

		# STOP lamers posting blank subjects / names
		# convert all blanks (space, tab, newline, etc.) to space
		unless ($name eq 'body') {
			$value =~ s/\s+/ /g;
		}
		# convert all double spaces (or more) to single spaces
		$value =~ s/  +/ /g;
		# if value of this field is nothing but a space, the value is null ("");
		if ($value eq ' ') {
			$value = "";
		}

		unless ($name eq 'body' && $allow_html == 1) {
			# change < to &lt;
			$value =~ s/</&lt;/g;
			# change > to &gt;
			$value =~ s/>/&gt;/g;
		#	$value =~ s/<[^>]*>//g;
		}

		#################################
		# HTML Extra Parse (Ken Williams) + TheGame + Overlord
		#

		# This still needs considerable improvement !
		# (suggestion by Overlord : only allow a specific list of tags ?)
		if ($name eq 'body' && $allow_html == 1) {
			$value =~ s@(<|&lt;?)\s?/?blink@&lt;BLINK@gi;
			# corrected bug !
			$value =~ s@(<|&lt;?)\s?/?script@&lt;SCRIPT@gi;
			$value =~ s@(<|&lt;?)\s?/?meta@&lt;META@gi;
			# who uses SSI tags that look like this ???
			$value =~ s@(<|&lt;?)\s?/?ssi@&lt;SSI@gi;
			$value =~ s@(<|&lt;?)\s?/?form@&lt;FORM@gi;

			$value =~ s@(<|&lt;?)\s?/?html@&lt;HTML@gi;
			$value =~ s@(<|&lt;?)\s?/?head@&lt;HEAD@gi;
			$value =~ s@(<|&lt;?)\s?/?title@&lt;TITLE@gi;
			$value =~ s@(<|&lt;?)\s?/?style@&lt;STYLE@gi;
			$value =~ s@(<|&lt;?)\s?/?isindex@&lt;ISINDEX@gi;
			$value =~ s@(<|&lt;?)\s?/?basefont@&lt;BASEFONT@gi;
			$value =~ s@(<|&lt;?)\s?/?base@&lt;BASE@gi;
			$value =~ s@(<|&lt;?)\s?/?frameset@&lt;FRAMESET@gi;
			$value =~ s@(<|&lt;?)\s?/?frame@&lt;FRAME@gi;
			$value =~ s@(<|&lt;?)\s?/?body@&lt;BODY@gi;
			$value =~ s@(<|&lt;?)\s?/?applet@&lt;APPLET@gi;
			$value =~ s@(<|&lt;?)\s?/?object@&lt;OBJECT@gi;
			$value =~ s@(<|&lt;?)\s?/?listing@&lt;LISTING@gi;
			$value =~ s@(<|&lt;?)\s?/?plaintext@&lt;PLAINTEXT@gi;
			$value =~ s@(<|&lt;?)\s?/?xmp@&lt;XMP@gi;

			# added for Netscape
			$value =~ s@(<|&lt;?)\s?/?layer@&lt;LAYER@gi;
			$value =~ s@(<|&lt;?)\s?/?embed@&lt;EMBED@gi;
			$value =~ s@(<|&lt;?)\s?/?ilayer@&lt;ILAYER@gi;

			# added for IE
			$value =~ s@(<|&lt;?)\s?/?iframe@&lt;IFRAME@gi;
			$value =~ s@(<|&lt;?)\s?/?bgsound@&lt;BGSOUND@gi;
			$value =~ s@(<|&lt;?)\s?/?input@&lt;INPUT@gi;
			$value =~ s@(<|&lt;?)\s?/?button@&lt;BUTTON@gi;
			$value =~ s@(<|&lt;?)\s?/?textarea@&lt;TEXTAREA@gi;
			$value =~ s@(<|&lt;?)\s?/?select@&lt;SELECT@gi;
			$value =~ s@(<|&lt;?)\s?/?optgroup@&lt;OPTGROUP@gi;
			$value =~ s@(<|&lt;?)\s?/?option@&lt;OPTION@gi;
			$value =~ s@(<|&lt;?)\s?/?comment@&lt;COMMENT@gi;

			# replace encoded &#.. values with normal a-zA-Z characters for javascript sploit detection
			while ($value =~ /\&#(\d+);/g) {
				$val = $1;
				if ( ($val >= 65 && $val <= 90) || ($val >= 97 && $val <= 122)) {
					$char = chr($val);
					$value =~ s/\&#$val;/$char/g;
				}
			}
			# same with hexa-encoded (not really supported by browsers)
			while ($value =~ /\&#x([0-9a-f]+);/gi) {
				$hex = $1;
				$val = hex($hex);
				if ( ($val >= 65 && $val <= 90) || ($val >= 97 && $val <= 122)) {
					$char = chr($val);
					$value =~ s/\&#x$hex;/$char/gi;
				}
			}

			# this still leaves a lot of possible javascript sploits !
			$value =~ s@script@scr1pt@gi;
			$value =~ s@alert@al3rt@gi;
			$value =~ s@location@locat1on@gi;

			# + future mod : remove onload etc. ?

			# try to catch tables that don't end - do this AFTER cut in get_variables !
			# try to catch blockquotes that don't end - do this AFTER cut in get_variables !
		}

		$FORM{$name} = $value;
	}

	# check some cookies here too
	if ($ENV{'HTTP_COOKIE'} || $ENV{'COOKIE'}) {
		$raw_cookie = $ENV{'HTTP_COOKIE'} || $ENV{'COOKIE'};
		undef @pairs;
		@pairs = split("; ", $raw_cookie);
		foreach $pair (@pairs) {
			# split into parts
			($name, $value) = split(/=/, $pair);

			# change +'s to spaces
			$name =~ tr/+/ /;
			# UN-URL-encode input
			$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

		# Note : there could be several values here, but we don't use them...
			# change +'s to spaces
			$value =~ tr/+/ /;
			# UN-URL-encode input
			$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

			if (!defined($cookie{$name})) {
				$cookie{$name} = $value;
			}
		}
	}

	##################
	# DES authentication mod
	#

	if ($use_DES == 1 || $use_rank == 1) {
		if (length($FORM{'magic'}) > 7 && $FORM{'magic'} =~ /^([B-Ks-x]+)$/) {
			$authnumraw = $1;
		}
		elsif (length($cookie{'magic'}) > 7 && $cookie{'magic'} =~ /^([B-Ks-x]+)$/) {
			$authnumraw = $1;
		}
		else {
			$randomnum = int(rand(100000));
			$authnumraw = '';
			foreach (split(//,reverse sprintf("%.4x%.4x",$ENV{'REMOTE_PORT'},$randomnum))) {
				$authnumraw .= pack("c", ord($_) + 18);
			}
		}

		$authnumdes = crypt($authnumraw,$dessalt);
		# -6 looks nicer than -5 on FreeBSD and VirtualAve
		#$authnum = substr($authnumdes,-5,5);
		$authnum = substr($authnumdes,-6,5);
	}
}


###################################
# 2. Get the current date and time for the board
#
# Uncomment gmtime(time) OR (localtime) but not both!
# localtime(time) = (Local Server Time Zone)
# gmtime(time) = GMT (Greenwich Mean Time Zone) 
#
# --> change $date and $long_date if you want
#

sub get_time {
	@months = ('January','February','March','April','May','June','July','August','September','October','November','December');
	@days = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');

	# (Local Server Time Zone)
	#($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time); # option one
	#($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime(time); # option one

	# (Greenwich Mean Time Zone) 
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime(time); # uncomment for GMT

	# $mon goes from 0 to 11
	$month = $months[$mon];
	$mon++;

	# $wday goes from 0 to 6
	$weekday = $days[$wday];

	# $year starts at 1900
	$year += 1900;

	# ugly number formatting - use sprintf() instead
	if ($sec < 10) { $sec = "0$sec"; }
	if ($min < 10) { $min = "0$min"; }
	if ($hour < 10) { $hour = "0$hour"; }
	if ($mday < 10) { $mday = "0$mday"; }
	if ($mon < 10) { $mon = "0$mon"; }

   ##################
   # $date is used on the main page of the board
   # --> change if you want (but adapt fd_admin.cgi too !)

	# Format: hh:mm:ss Day/Month/Year (Default)
	if ($use_time == 1) {
		$date = "$hour:$min:$sec $mday/$mon/$year";
	}
	# Format: Day/Month/Year
	elsif ($use_time == 2) {
		$date = "$mday/$mon/$year";
	}
	# Format: hh:mm:ss Month/Day/Year
	elsif ($use_time == 3) {
		$date = "$hour:$min:$sec $mon/$mday/$year";
	}
	# Format: Month/Day/Year
	elsif ($use_time == 4) {
		$date = "$mon/$mday/$year";
	}
	# Format: hh:mmAM/PM Month/Day/Year
	elsif ($use_time == 5) {
		# remove ugly 0 again :)
		$hour2 = sprintf("%d",$hour);
		if ($hour2 < 12) { # is it 0:01 AM or 12:01 AM for 00:01:15 ?
			$ampm = "AM";
		}
		elsif ($hour2 > 12) {
			$hour2 -= 12;
			$ampm = "PM";
		}
		else {
			$ampm = "PM";
		}
		$date = "$hour2:$min$ampm $mon/$mday/$year";
	}


   ##################
   # $long_date is used in the message itself
   # --> change if you want

	if ($use_time == 5) {
		$long_date = "$weekday, $month $mday, $year at $hour2:$min$ampm";
	}
	else {
		$long_date = "$weekday, $month $mday, $year at $hour:$min:$sec";
	}
} 


###################################
# 3. Log Users (Ken Williams, cyberarmy)
#

sub log {
	open(LOG,">>$datadir/$logfile") || show_die("Can't open log file - $!\n");
	# Locking is not really necessary, but it should reduce the risk of having log
	# entries interleaved with others...
	flock(LOG, $lock_ex) || show_die("Can't flock log file - $!\n");

   ##################
   # Specify what you want to log
   #

	# log time, IP, name and subject only (choose some "easy to parse" format)
#	print LOG "$year/$mon/$mday $hour:$min:$sec\t$ENV{'REMOTE_ADDR'}\t$FORM{'name'}\t$FORM{'subject'}\n";

	# full logging
	# + identify each unique request with the process ID ($$)
	print LOG "$$: Environment variables - $date :\n";
	# print CONTENT_*, HTTP_*, QUERY_*, REMOTE_*, REQUEST_*
	foreach $key (sort keys %ENV) {
		if ($key =~ /^[CHQR]/) {
			print LOG "$$: $key = $ENV{$key}\n";
		}
	}
	# see what the script used for variables
	print LOG "$$: Form variables - $date :\n";
	foreach $key (reverse sort keys %FORM) {
		print LOG "$$: $key = $FORM{$key}\n";
	}
	# see what the poster really sent
	print LOG "$$: What was really posted - $date :\n";
	if (length($buffer) > 4000) {
		print LOG substr($buffer,0,4000), "\n[snip]\n";
	}
	else {
		print LOG "$buffer\n";
	}
	print LOG "\n";

	close LOG;
}


###################################
# 4. Environment Lock Protection
#

sub check_url {

	#######################################
	# env lock
	#

	if ((!$ENV{'HTTP_REFERER'}) || (!$ENV{'CONTENT_LENGTH'}) ||
		(!$ENV{'HTTP_ACCEPT'}) || (!$ENV{'HTTP_USER_AGENT'}))
	{
		if ($log_warnings == 1) {
			log_msg("WARNING : Missing HTTP header(s) from $ENV{'REMOTE_ADDR'} = $FORM{'name'} ($FORM{'magic'})\n");
		}
		&error('bad_headers');
	}

	my($check_referer) = 0;

	# already checked if we have a referrer or not
	foreach $referer (@referers) {
		if ($ENV{'HTTP_REFERER'} =~ m|https?://([^/]*)$referer|i) {
			$check_referer = 1;
			last;
		}
	}

	if ($check_referer != 1) {
		if ($log_warnings == 1) {
			log_msg("WARNING : Bad referer $ENV{'HTTP_REFERER'} from $ENV{'REMOTE_ADDR'} = $FORM{'name'} ($FORM{'magic'})\n");
		}
		&error('bad_referer')
	}
}

###################################
# 5. Magic Chicken Ban Check
#
# Note that this word has to be the same as in the ban_user error routine !
#

sub check_magic {
	if ($FORM{'magic'} =~ /rubberchicken/i || $ENV{'HTTP_COOKIE'} =~ /rubberchicken/i)
	{
		if ($log_banned == 1) {
			log_msg("BANNED : Bad magic from $ENV{'REMOTE_ADDR'} = $FORM{'name'} ($FORM{'magic'})\n");
		}
		&error('ban_user');
	}

}


###################################
# 6. User Ban Mod (Ken Williams)
#
# Format adapted for use with ban_time :
# -1	XXX.XXX.XXX.XXX		(IP address banned forever)
# -1	XXX.XXX.		(subnet banned forever)
# 949852299	XXX.XXX.XXX.XXX	(IP address banned until this time + ban_time - at least !)
# etc.
#
# You can edit this ip_file manually too if you want, but make sure you use TABs between each field !
#

sub check_ip {

	# set $user_ip to the IP of the person posting
	$user_ip = $ENV{'REMOTE_ADDR'};
	# set $ok to 1
	$ok=1;
	# set $now to now
	$now = time;

	# open for read/write to allow flock to work on most platforms, even those with lockf(3)
	open(FILE,"+<$datadir/$ip_file") || show_die("Can't open ip file - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock ip file - $!\n");
	@IP_lines = <FILE>;
	close(FILE);

	# Note 1 : ban times are updates in error('ban_user')
	# Note 2 : we don't check for other things here to avoid DoSsing of people
	#          (well, proxies may get banned, but that's unavoidable)

	foreach $ip_line (@IP_lines) {
		chomp($ip_line);
		($dtime,$dip) = split(/\t/,$ip_line);

	## banned signature found
		if ($authnum =~ /$dip/) {
			$ok = 0;
			# bail out, we've seen enough
			last;
		}

	## banned hostname found
		if ($host =~ /$dip/) {
			$ok = 0;
			# bail out, we've seen enough
			last;
		}

	## banned registered name found
		if ($use_dbauth == 1 && $name =~ /$dip/) {
			$ok = 0;
			# bail out, we've seen enough
			last;
		}

	## banned IP found
		# regex here to allow subnet banning
		if ($user_ip =~ /^$dip/) {
			if ($dtime < 0 || $ban_time < 0 || $dtime + $ban_time >= $now) {
				$ok = 0;
				# bail out, we've seen enough
				last;
			}
		}
	}

	# if ban has been detected
	if ($ok == 0)
	{
		if ($log_banned == 1) {
			log_msg("BANNED : Banned IP found for $ENV{'REMOTE_ADDR'} = $FORM{'name'} ($FORM{'magic'})\n");
		}
		&error('ban_user');
	}
}


###################################
# 7. Get host information
#
# --> change $environ if you want
#
# ($addr_type is defined above, but it's
# better to 'use Socket' for this)
#

sub get_host {

  ###############################
  # User Info Mod (Ken Williams) & complex
  #
	$addr = $ENV{'REMOTE_ADDR'};

	# REMOTE_HOST is unreliable/unavailable on several webhosting sites !
	#$host = $ENV{'REMOTE_HOST'};
	$host = gethostbyaddr(pack("C4",split(/\./,$addr)), $addr_type);
	# check twice to deal with timeout
	#if ($host eq '') {
	#	# remove this if things are too slow...
	#	sleep(1);
	#	$host = gethostbyaddr(pack("C4",split(/\./,$addr)), $addr_type);
	#}

	# If you only use $host below, remove the # here !
	# Otherwise, we don't want to repeat the IP address if we don't have a hostname
	#if ($host eq "") { $host=$ENV{'REMOTE_ADDR'}; }
	if ($host eq "") { $host='?'; }

	$bwr = $ENV{'HTTP_USER_AGENT'};
	# only plain ASCII characters allowed here
	$bwr =~ tr/\040-\176//cd;
	# sploit found by complex
	$bwr =~ s/<[^>]*>/(CUT)/g;
	# remove some characters we don't want to see here
	$bwr =~ tr/<>&"//d;
	$bwr =~ s/\s+/ /g;
	# some arbitrary size limit
	if (length($bwr) > 120)
	{
		$bwr = substr($bwr, 0, 120);
	}

	# if you change this, make sure the fd_find.cgi still shows the name correctly !

						# Advanced Users - choose...
	#$environ = "[$addr ($host)] [$bwr]";	# Show all info about poster
	#$environ = "[$addr] [$host]";
	#$environ = "from $addr ($host)";	# Show IP (hostname)
	$environ = "from $host ($addr)";	# Show hostname (IP) (default)
	#$environ = "[$host][$bwr]";
	#$environ = "[from $host using $bwr]";
	#$environ = "[$addr]";
	#$environ = "[$addr] [$bwr]";

	# Note : the proxy mod below could add some things to this, so
	# check it out if you activate the proxy mod !


  #######################################
  # Vanity Mod (webmaster@cyberarmy.com)
  #

	if ($addr eq $your_ip) { $environ = "[Boardmaster]"};


  #######################################
  # Special domain bans :
  #

	#if ($host =~ /aol./i) { # ban all AOL users
	#	if ($log_warnings == 1) {
	#		log_msg("WARNING : Banned domain for $host ($ENV{'REMOTE_ADDR'}) = $FORM{'name'} ($FORM{'magic'})\n");
	#	}
	#	&error('aol');
	#}

}


###################################
# 8. Get Variables
#

sub get_variables {
	if ($FORM{'followup'}) {
		$followup = "1";
		my($item);
		my(@list) = split(/,/,$FORM{'followup'});
		@followup_num = ();
		foreach $item (@list) {
			if ($item =~ /(\d+)/) {
				push(@followup_num,$1);
			}
		}
		$num_followups = @followups = @followup_num;
	# fatal sploit for WWWBoard Bomb Patch if this is placed before it !
	#	$last_message = pop(@followups);
		$last_message = $followups[-1];
		$origdate = "$FORM{'origdate'}";
		$origname = "$FORM{'origname'}";
		$origsubject = "$FORM{'origsubject'}";
	# currently not in use
	#	$origemail = "$FORM{'origemail'}";
	#	$origemail =~ s/'//g;
	#	$origemail =~ s/\s+on.*$//i;

		# WWWBoard Bomb Patch 
		# Written By: Samuel Sparling (sparling@slip.net)
		# (check Perl FAQ 4 for a better way)
		$fn=0;
		while ($fn < $num_followups)
		{
			$dfn=0;
			while ($dfn < $num_followups)
			{
				if ($followups[$dfn] == $followups[$fn] && $dfn != $fn)
				{
					if ($log_warnings == 1) {
						log_msg("WARNING : Board bomb from $host ($ENV{'REMOTE_ADDR'}) = $FORM{'name'} ($FORM{'magic'})\n");
					}
					&error('board_bomb');
				}
				$dfn++;
			}
			$fn++;
		}
		# End WWWBoard Bomb Patch
	}
	else {
		$followup = "0";
	}

	$FORM{'name'} =~ s/&quot;//g;
	if ($FORM{'name'}) {
		$name = "$FORM{'name'}";

		#no test mod (cyberarmy)
		if ($no_tests == 1)
		{
			# only words starting with 'test' now
			if ($name =~ /\btest/i) { &error('test')};
		}
	}
	elsif ($use_dbauth == 0) {
		&error('no_name');
	}
	else {
		$name = ''; # we'll come back to this in do_civilians
	}

	# not a good check here
	if ($FORM{'email'} =~ /.*\@.*\..*/) {
		$email = "$FORM{'email'}";
		$email =~ s/'//g;
		# remove any onload() etc. events
		$email =~ s/\s+on.*$//i;
	}

	if ($FORM{'subject'}) {
		$subject = "$FORM{'subject'}";

		#no test mod (cyberarmy)
		if ($no_tests == 1)
		{
			# only words starting with 'test' now
			if ($subject =~ /\btest/i) { &error('test')};
		}
	}
	else {
		&error('no_subject');
	}

	# slightly improved check
	if ($FORM{'url'} =~ /^(ht|f)tps?:\/\/.*\..*/ && $FORM{'url_title'}) {
		$message_url = "$FORM{'url'}";
		$message_url_title = "$FORM{'url_title'}";
		# not too sure about this one - leave it here for now...
		#$message_url =~ s/'//g;
		# remove any onload() etc. events
		$message_url =~ s/\s+on.*$//i;
	}

	# slightly improved check
	if ($FORM{'img'} =~ /^(ht|f)tp:\/\/.*\..*/) {
		$message_img = "$FORM{'img'}";
		# anti hurlant for javascript
		$message_img =~ s/'//g;
		#$message_img =~ s/"//g;
		# remove any onload() etc. events
		$message_img =~ s/\s+on.*$//i;
	}

	if ($FORM{'body'}) {
		$body = "$FORM{'body'}";
		$body =~ s/\r//g;
		$body =~ s/\n\n/<p>/g;
		$body =~ s/\n/<br>/g;
		# put quotes back where they belong
		if ($allow_html == 1) {
			$body =~ s/&quot;/"/g;
		}
	}
	else {
		&error('no_body');
	}

	# rank mod
	if ($FORM{'rcode'}) {
		$rcode = "$FORM{'rcode'}";
		$rank = $rankcode{$rcode};
	}


	##################
	# Length Abuse Mod (Epicurus, cyberarmy)
	#

	if ($cut_fields == 1)
	{
		if (length($name) > $max_name)
		{
			$name = substr($name, 0, $max_name);
		}
		if (length($body) > $max_body)
		{
			$body = substr($body, 0, $max_body);
			$body .= "\n[snip - maximum size exceeded]\n";
		}

		if ($allow_html == 1) {
			# try to catch tables that don't end - do this AFTER cut !
			$table_start = 0;
			while ($body =~ m#(<|&lt;?)\s?table#gi) {
				$table_start++;
			}
			$table_end = 0;
			while ($body =~ m#(<|&lt;?)\s?/table#gi) {
				$table_end++;
			}
			if ($table_end < $table_start - 5) { # too many open tables !
				$body =~ s@(<|&lt;?)\s?table@&lt;table@gi;
			}
			elsif ($table_end < $table_start) {
				for ($i = $table_end; $i < $table_start; $i++) {
					$body .= "\n</table>";
				}
			}

			# try to catch blockquotes that don't end - do this AFTER cut !
			$block_start = 0;
			while ($body =~ m#(<|&lt;?)\s?blockquote#gi) {
				$block_start++;
			}
			$block_end = 0;
			while ($body =~ m#(<|&lt;?)\s?/blockquote#gi) {
				$block_end++;
			}
			if ($block_end < $block_start - 5) { # too many open blockquotes !
				$body =~ s@(<|&lt;?)\s?blockquote@&lt;blockquote@gi;
			}
			elsif ($block_end < $block_start) {
				for ($i = $block_end; $i < $block_start; $i++) {
					$body .= "\n</blockquote>";
				}
			}
		}

		# not $url
		if (length($message_url) > $max_url)
		{
			$message_url = substr($message_url, 0, $max_url);
		}
		# not $url_title
		if (length($message_url_title) > $max_url_title)
		{
			$message_url_title = substr($message_url_title, 0, $max_url_title);
		}
		if (length($email) > $max_email)
		{
			$email = substr($email, 0, $max_email);
		}
		# not $img
		if (length($message_img) > $max_img)
		{
			$message_img = substr($message_img, 0, $max_img);
		}
		if (length($subject) > $max_subject)
		{
			if ($followup == 1)
			{
				$subject = substr($subject, 0, ($max_subject+4));
			}
			else
			{
				$subject = substr($subject, 0, $max_subject);
			}
		}
		# forgot to check these too
		# origname = name + environ
		if (length($origname) > 180)
		{
			$origname = substr($origname, 0, 180);
		}
		if (length($origsubject) > $max_subject)
		{
			$origsubject = substr($origsubject, 0, ($max_subject+4));
		}
		# some arbitrary limit
		if (length($origdate) > 120)
		{
			$origdate = substr($origdate, 0, 120);
		}
	# currently not in use
		if (length($origemail) > $max_email)
		{
			$origemail = substr($origemail, 0, $max_email);
		}
	}

	if ($quote_text == 1) {
		$hidden_body = "$body";
		$hidden_body =~ s/</&lt;/g;
		$hidden_body =~ s/>/&gt;/g;
		$hidden_body =~ s/"/&quot;/g;
	}
}


###################################
# 9. Anti-Spam Mod (Epicurus, ripped from now dead New Board)
#
# modified to simply keep the time(), and also improve catching
# of spammers. The last time of spam gets updated every time too...
#

sub no_spam
{
	# set $user_ip to the IP of the person posting
	$user_ip = $ENV{'REMOTE_ADDR'};
	# what if the name in the cookie is different ?
	$user_name = $name;
	$user_magic = $FORM{'magic'} || $cookie{'magic'};
	# set $ok to 1
	$ok=1;
	# set $now to now
	$now = time;

	open(FILE,"+<$datadir/$no_spam_file") || show_die("Can't open nospam file - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock nospam file - $!\n");
	@time_lines = <FILE>;
	seek(FILE,0,0);
	truncate(FILE,0) || show_die("Can't truncate nospam file - $!\n");

	foreach $time_line (@time_lines) {
		chomp($time_line);
		($dtime,$daddr,$dname,$dmagic) = split(/\t/,$time_line);
		if ($daddr eq $user_ip || ($dname ne '' && $dname eq $user_name) || ($dmagic ne '' && $dmagic eq $user_magic)) {
			if ($dtime + $spam_time >= $now) {
				$ok = 0;
				# don't bail out, we need to re-print the rest too
			}
		}
		elsif ($dtime + $spam_time >= $now) {
			print FILE "$time_line\n";
		}
		# don't print old entries
	}
	print FILE "$now\t$user_ip\t$user_name\t$user_magic\n";
	close(FILE);

	# if spam has been detected
	if ($ok == 0)
	{
		if ($log_warnings == 1) {
			log_msg("WARNING : Spam attempt from $host ($ENV{'REMOTE_ADDR'}) = $FORM{'name'} ($FORM{'magic'})\n");
		}
		&error('no_spam');
	}
}


###################################
# 10. Automatic ban check
#

sub check_autoban {
	open(BANWORDS,"<$datadir/$autoban_file") || show_die("Can't open autoban file - $!\n");
	# this file doesn't get updated by the script, so no locking is required
	@banwords = <BANWORDS>;
	close(BANWORDS);

	$banword_found = 0;
	foreach $banword (@banwords) {
		chomp($banword);
		if (($body =~ /$banword/i) ||
		    ($message_img =~ /$banword/i) ||
		    ($subject =~ /$banword/i) ||
		    ($name =~ /$banword/i) ||
		    ($email =~ /$banword/i) ||
		    ($message_url_title =~ /$banword/i))
		{
			$banword_found = 1;
			last;
		}
	}
	if ($banword_found == 1) {
		if ($log_banned == 1) {
			log_msg("BANNED : Banned word $banword from $host ($ENV{'REMOTE_ADDR'}) = $FORM{'name'} ($FORM{'magic'})\n");
		}
		&error('ban_user');
	}
}


###################################
# 11. C.Y.R.Y.L Topic Ban Mod
# (DBasics.com, Cyberarmy)
#

sub topicban { 
	open(BADWORDS,"<$datadir/$topicban_file") || show_die("Can't open topicban file - $!\n");
	# this file doesn't get updated by the script, so no locking is required
	@badwords = <BADWORDS>;  
	close(BADWORDS);

	$badword_found = 0;
	foreach $badword (@badwords) {
		chomp($badword);
		if (($body =~ /$badword/i) ||
		    ($message_img =~ /$badword/i) ||
		    ($subject =~ /$badword/i) ||
		    ($name =~ /$badword/i) ||
		    ($email =~ /$badword/i) ||
		    ($message_url_title =~ /$badword/i))
		{
			$badword_found = 1;
			# show bad word again
			$thisisbad = $badword;
			last;
		}
	}
	if ($badword_found == 1) {
		if ($log_warnings == 1) {
			log_msg("WARNING : Topic ban $thisisbad from $host ($ENV{'REMOTE_ADDR'}) = $FORM{'name'} ($FORM{'magic'})\n");
		}
		&error('bad_words');
	}
}

# The proxy mod comes here, but since it's still a beta version,
# we place the code at the end of the script

###################################
# 12. Get Data Number Subroutine
#

sub get_number {
	open(NUMBER,"+<$datadir/$datafile") || show_die("Can't open datafile - $!\n");
	flock(NUMBER, $lock_ex) || show_die("Can't flock datafile - $!\n");
	$n = <NUMBER>;
	seek(NUMBER,0,0);

	if ($n =~ /(\d+)/) {
		$num = $1;
	}
	else {
		if ($log_errors == 1) {
			log_msg("Board Script Error : The data number is messed up : '$n'\n");
		}
		$num = 0;
	}

	# for autocut mod
	$cut = ($num - $max_posts);

	# no more max number
	$num++;

	truncate(NUMBER,0) || show_die("Can't truncate datafile - $!\n");
	print NUMBER "$num";
	close NUMBER;


}


###################################
# 13. New File Subroutine
#

sub new_file {
	open(NEWFILE,">$basedir/$mesgdir/$num\.$ext") || show_die("Can't open new file $num - $!\n");
	flock(NEWFILE, $lock_ex) || show_die("Can't flock new file $num - $!\n");

	print NEWFILE <<EOT1;
<HTML>
<HEAD>
	<TITLE>$subject</TITLE>

<SCRIPT LANGUAGE="JavaScript">
<!--
 // retrieve a cookie.
 function getCookie(name) {
  var cname = name + "=";
  var dc = document.cookie;
  if (dc.length > 0) {
   begin = dc.indexOf(cname);
   if (begin != -1) {
    begin += cname.length;
    end = dc.indexOf(";", begin);
    if (end == -1) end = dc.length;
    return unescape(dc.substring(begin, end));
   }
  }
  return null;
 }
 // save a cookie.
 function setCookie(name, value, expires) {
  document.cookie = name + "=" + escape(value) + "; path=/" + ((expires == null) ? "" : "; expires=" + expires.toGMTString());
 }
 // delete a cookie.
 function delCookie(name) {
  document.cookie = name + "=; expires=Thu, 01-Jan-70 00:00:01 GMT" + "; path=/";
 }
 // retrieve form element's value.
 function getValue(element) {
  var value = getCookie(element.name);
  if (value != null) element.value = value;
 }
 // save form element's value.
 function setValue(element) {
  setCookie(element.name, element.value, exp);
 }
 var exp = new Date();
 exp.setTime(exp.getTime() + (1000 * 3600 * 24 * 365));
// -->
</SCRIPT>
</HEAD>

$background
<CENTER><H1>$subject</H1></CENTER>
<HR WIDTH="80%" SIZE="6" COLOR="#000000" ALIGN="center">
<P ALIGN="center">
EOT1

	if ($show_faq == 1) {
		print NEWFILE "<center>[<a href=\"#followups\">Follow Ups</a>] [<a href=\"#postfp\">Post Followup</a>] [<a href=\"$baseurl/$mesgfile\">$title</a>] [<a href=\"$baseurl/$faqfile\">FAQ</a>]</center></p>\n";
	}
	else {
		print NEWFILE "<center>[<a href=\"#followups\">Follow Ups</a>] [<a href=\"#postfp\">Post Followup</a>] [<a href=\"$baseurl/$mesgfile\">$title</a>]</center></p>\n";
	}

	print NEWFILE "<hr width=\"80%\" size=\"6\" color=\"#000000\" align=\"center\"><p>\n";
	print NEWFILE "Posted by ";

	if ($email) {
		print NEWFILE "<a href=\"mailto:$email\">$name</a> $environ on $long_date :\n<p>\n";
	}
	else {
		print NEWFILE "$name $environ on $long_date :\n<p>\n";
	}

	if ($followup == 1) {
		print NEWFILE "In Reply to: <a href=\"$last_message\.$ext\">$origsubject</a> posted by ";
		if ($origemail) {
			print NEWFILE "<a href=\"mailto:$origemail\">$origname</a> on $origdate :\n<p>\n";
		}
		else {
			print NEWFILE "$origname on $origdate :\n<p>\n";
		}
	}


	if ($use_rank == 1) {
		if ($rank ne '') {
			print NEWFILE "<center><img src=\"$rankbadge{$rank}\"><br><small><i>$rankname{$rank} $name</i></small></center><p>";
		}
		else {
			# to be defined
		}
	} # end of use_rank

	if ($message_img) {
		print NEWFILE "<center><img src=\"$message_img\"></center><p>\n";
	}

	$nicerbody = $body;
	$nicerbody =~ s/<br>/<br>\n/g;
	$nicerbody =~ s/<p>/\n<p>\n/g;
	print NEWFILE "$nicerbody\n<br><br>\n";

	# added for HTML format spoilers - of limited use only !
	if ($allow_html == 1) {
		print NEWFILE "<table><tr><td><font face=\"arial\">\n";
	}

	if ($use_DES == 1) {
		print NEWFILE "<em>-- $name<br>-- signature $authnum.</em><br>\n";
	}

	if ($message_url) {
		print NEWFILE "<ul><li><a href=\"$message_url\">$message_url_title</a></ul>\n";
	}

	##################
	# Warning : do NOT modify the <!--insert: and <!--end: tags below !
	#

	print NEWFILE <<EOT2;
<br>
<HR WIDTH="80%" SIZE="6" COLOR="#000000" ALIGN="center">
<p>
<a name="followups">Follow Ups:</a>
<br><font face="arial" size="2">
<ul><!--insert: $num-->
</ul><!--end: $num-->
</font><br>
<HR WIDTH="80%" SIZE="6" COLOR="#000000" ALIGN="center">
<p>
<a name="postfp">Post a Followup</a>
<p>
<form method=POST name="MyForm" action="$cgi_url">
EOT2

	print NEWFILE "<input type=hidden name=\"followup\" value=\"";
	if ($followup == 1) {
		foreach $followup_num (@followup_num) {
			print NEWFILE "$followup_num,";
		}
	}
	print NEWFILE "$num\">\n";

	print NEWFILE "<input type=hidden name=\"origname\" value=\"$name $environ\">\n";

	if ($email) {
		print NEWFILE "<input type=hidden name=\"origemail\" value=\"$email\">\n";
	}

	if ($use_dbauth == 1) {
		print NEWFILE <<EOT3;
<input type=hidden name="origsubject" value="$subject">
<input type=hidden name="origdate" value="$long_date">

<TABLE WIDTH="350">
<TR><TH ALIGN=right><FONT FACE="arial" SIZE="2">Name:</FONT></TH>
<TD><INPUT TYPE=text NAME="name" SIZE=30 MAXLENGTH=$max_name onBlur="setValue(this)"></TD><TR>
<TR><TH ALIGN=right><FONT FACE="arial" SIZE="2">E-Mail:</FONT></TH>
<TD><INPUT TYPE=text NAME="email" SIZE=30 MAXLENGTH=$max_email onBlur="setValue(this)"> (<INPUT TYPE=checkbox name="showemail"> default )</TD></TR>
<TR><TH ALIGN=right><FONT FACE="arial" SIZE="2">Subject:</FONT></TH>
<TD>
EOT3
	}
	else {
		print NEWFILE <<EOT3;
<input type=hidden name="origsubject" value="$subject">
<input type=hidden name="origdate" value="$long_date">

<TABLE WIDTH="350">
<TR><TH ALIGN=right><FONT FACE="arial" SIZE="2">Name:</FONT></TH>
<TD><INPUT TYPE=text NAME="name" SIZE=30 MAXLENGTH=$max_name onBlur="setValue(this)"></TD><TR>
<TR><TH ALIGN=right><FONT FACE="arial" SIZE="2">E-Mail:</FONT></TH>
<TD><INPUT TYPE=text NAME="email" SIZE=30 MAXLENGTH=$max_email onBlur="setValue(this)"></TD></TR>
<TR><TH ALIGN=right><FONT FACE="arial" SIZE="2">Subject:</FONT></TH>
<TD>
EOT3
	}

	##################
	# Show subject line or not, depending on $subject_line
	#

	$max_subject += 4;
	if ($subject_line == 1) {
		if ($subject_line =~ /^Re:/) {
			print NEWFILE "<INPUT TYPE=hidden NAME=\"subject\" SIZE=45 MAXLENGTH=$max_subject value=\"$subject\">";
			print NEWFILE "<b>$subject</b>";
		}
		else {
			print NEWFILE "INPUT TYPE=hidden NAME=\"subject\" SIZE=45 MAXLENGTH=$max_subject value=\"Re: $subject\">";
			print NEWFILE "<b>Re: $subject</b>";
		}
	}
	elsif ($subject_line == 2) {
		print NEWFILE "<INPUT TYPE=text NAME=\"subject\" SIZE=45 MAXLENGTH=$max_subject>";
	}
	else {
		if ($subject =~ /^Re:/) {
			print NEWFILE "<INPUT TYPE=text NAME=\"subject\" SIZE=45 MAXLENGTH=$max_subject value=\"$subject\">";
		}
		else {
			print NEWFILE "<INPUT TYPE=text NAME=\"subject\" SIZE=45 MAXLENGTH=$max_subject value=\"Re: $subject\">";
		}
	}

	print NEWFILE <<EOT4;
</TD></TR>
<TR>
<TD VALIGN="top">
<FONT FACE="arial" SIZE="2"><B>Message:</FONT></B><BR>
</TD>
<TD>
<TEXTAREA COLS=45 ROWS=10 NAME="body" WRAP="soft">
EOT4

	if ($quote_text == 1) {
		@chunks_of_body = split(/\&lt\;p\&gt\;/,$hidden_body);
		foreach $chunk_of_body (@chunks_of_body) {
			@lines_of_body = split(/\&lt\;br\&gt\;/,$chunk_of_body);
			foreach $line_of_body (@lines_of_body) {
				print NEWFILE ": $line_of_body\n";
			}
			print NEWFILE "\n";
		}
	}

	# added for HTML format spoilers - of limited use only !
	if ($allow_html == 1) {
		$page_bottom =~ s@</body>@</td></tr></table></body>@i;
	}

	if ($use_dbauth == 1) {
		print NEWFILE <<EOT5;
</TEXTAREA>
</TD>
</TR>
</TABLE>
<TABLE>
<TR><TH COLSPAN=2 ALIGN=left><FONT FACE="arial" SIZE="2">Optional Link</FONT> (<INPUT TYPE=checkbox name="showurl" checked> default )</TH></TR>
<TR><TH ALIGN=right><FONT FACE="arial" SIZE="2">URL:</FONT></TH>
<TD><INPUT TYPE=text NAME="url" SIZE=44 MAXLENGTH=$max_url onBlur="setValue(this)"></TD></TR>
<TR><TH ALIGN=right><FONT FACE="arial" SIZE="2">Title:</FONT></TH>
<TD><INPUT TYPE=text NAME="url_title" SIZE=44 MAXLENGTH=$max_url_title onBlur="setValue(this)"></TD></TR>
<TR><TH COLSPAN=2 ALIGN=left><FONT FACE="arial" SIZE="2">Optional Image Link</FONT> (<INPUT TYPE=checkbox name="showimg" checked> default )</TH></TR>
<TR><TH ALIGN=right><FONT FACE="arial" SIZE="2">URL:</FONT></th>
<TD><INPUT TYPE=text NAME="img" SIZE=44 MAXLENGTH=$max_img onBlur="setValue(this)"> <input type="hidden" name="magic" onBlur="setValue(this)"><th><input type="hidden" name="rcode" onBlur="setValue(this)"> </TD></TR>
</TABLE><P>
<INPUT TYPE="hidden" NAME="action" VALUE="post_new">
<center><INPUT TYPE=submit VALUE="Post Message"></CENTER>
</form>

EOT5
	}
	else {
		print NEWFILE <<EOT5;
</TEXTAREA>
</TD>
</TR>
</TABLE>
<TABLE>
<TR><TH COLSPAN=2 ALIGN=left><FONT FACE="arial" SIZE="2">Optional Link</FONT></TH></TR>
<TR><TH ALIGN=right><FONT FACE="arial" SIZE="2">URL:</FONT></TH>
<TD><INPUT TYPE=text NAME="url" SIZE=44 MAXLENGTH=$max_url onBlur="setValue(this)"></TD></TR>
<TR><TH ALIGN=right><FONT FACE="arial" SIZE="2">Title:</FONT></TH>
<TD><INPUT TYPE=text NAME="url_title" SIZE=44 MAXLENGTH=$max_url_title onBlur="setValue(this)"></TD></TR>
<TR><TH COLSPAN=2 ALIGN=left><FONT FACE="arial" SIZE="2">Optional Image Link</FONT></TH></TR>
<TR><TH ALIGN=right><FONT FACE="arial" SIZE="2">URL:</FONT></th>
<TD><INPUT TYPE=text NAME="img" SIZE=44 MAXLENGTH=$max_img onBlur="setValue(this)"> <input type="hidden" name="magic" onBlur="setValue(this)"><th><input type="hidden" name="rcode" onBlur="setValue(this)"> </TD></TR>
</TABLE><P>
<INPUT TYPE="hidden" NAME="action" VALUE="post_new">
<center><INPUT TYPE=submit VALUE="Post Message"></CENTER>
</form>

EOT5
	}

	print NEWFILE <<EOT6;
<SCRIPT LANGUAGE="JavaScript">
<!--
var MyForm = document.MyForm;
 MyForm.name.Value = getValue(MyForm.name);
 MyForm.email.Value = getValue(MyForm.email);
 MyForm.url.Value = getValue(MyForm.url);
 MyForm.url_title.Value = getValue(MyForm.url_title);
 MyForm.img.Value = getValue(MyForm.img);
 MyForm.rcode.Value = getValue(MyForm.rcode);
 MyForm.magic.Value = getValue(MyForm.magic);
// -->
</SCRIPT>

$page_bottom
EOT6

	# added for HTML format spoilers - of limited use only !
	if ($allow_html == 1) {
		$page_bottom =~ s@</td></tr></table></body>@</body>@i;
	}

	close(NEWFILE);
}


###################################
# 14. Main WWWBoard Page Subroutine
#

sub main_page {
	open(MAIN,"+<$basedir/$mesgfile") || show_die("Can't open message file - $!\n");
	flock(MAIN, $lock_ex) || show_die("Can't flock message file - $!\n");
	@main = <MAIN>;
	seek(MAIN,0,0);
	truncate(MAIN,0) || show_die("Can't truncate message file - $!\n");

	#################################
	# Autocut Mod (www.cyberarmy.com)
	# - if you are stealing this mod (thats fine), it also uses a small mod to
	# the get data number sub, and some changes to the variables section.
	#

	# remove old message ($cut is defined in get_number)
	if ($auto_cut == 1 && $cut > 0)
	{
		foreach ($j = 0;$j <= @main;$j++) {
			if ($main[$j] =~ /<!--top: $cut-->/) {
				splice(@main, $j, 3);
				$j -= 3;
			}
			elsif ($main[$j] =~ /<!--end: $cut-->/) {
				splice(@main, $j, 1);
				$j--;
			}
		}
	}

	if ($followup == 0) {

		foreach $main_line (@main) {
			if ($main_line =~ /<!--begin-->/) {
				print MAIN "<!--begin-->\n";
				print MAIN "<!--top: $num--><li><a href=\"$mesgdir/$num\.$ext\">";

				if ($use_rank == 1) {
					if ($rank ne '') {
						print MAIN "<font color=#FFAA33>";
					}
					# highlight posts by higher ranks
					for $i (0 .. $rankhighlight) {
						if ($rank eq $ranklist[$i]) {
							print MAIN "<b> ";
							last;
						}
					}
				} # end of use_rank

				print MAIN "$subject";

				if ($use_rank == 1) {
					# highlight posts by higher ranks
					for $i (0 .. $rankhighlight) {
						if ($rank eq $ranklist[$i]) {
							print MAIN "</b>";
							last;
						}
					}
					if ($rank ne '') {
						print MAIN "</font>";
					}
				} # end of use_rank
				print MAIN "</a> <font face=\"arial\" size=\"2\" color=#ffffff>- <b>";

				if ($use_rank == 1) {
					if ($rank ne '') {
						print MAIN "$ranktitle{$rank} ";
					}
					else {
						print MAIN "$civiliantitle ";
					}
				} # end of use_rank

				print MAIN "$name</b> ";

				if ($use_rank == 1) {
					if ($rank ne '') {
						print MAIN "<img src=\"$rankbadge{$rank}\" height=$badgeheight width=$badgewidth>";
					}
					else {
						# to be defined
					}
				} # end of use_rank

				if ($show_unix == 1) {
					if (($ENV{'HTTP_USER_AGENT'} =~ /nix/i) ||
					    ($ENV{'HTTP_USER_AGENT'} =~ /nux/i) ||
					    ($ENV{'HTTP_USER_AGENT'} =~ /lynx/i) ||
					    ($ENV{'HTTP_USER_AGENT'} =~ /X11/i) ||
					    ($rank eq $ranklist[0]) )
					{
						print MAIN "<img src=\"$unixbadge\" height=15 width=15> ";
					}
				}

				if ($use_DES == 1) {
					print MAIN " <i>$date</i> ($authnum)</font>\n";
				}
				else {
					print MAIN " <i>$date</i></font>\n";
				}

				# we still need a line here for the splice stuff above (and in fd_admin.cgi)
				if ($show_respnum == 1) {
					print MAIN "(<!--responses: $num-->0)\n";
				}
				else {
					print MAIN "<!--responses: -->\n";
				}
				print MAIN "<ul><!--insert: $num-->\n";
				print MAIN "</ul><!--end: $num-->\n";
			}
			else {
				print MAIN "$main_line";
			}
		}
	}
	else {
		foreach $main_line (@main) {
			$work = 0;
			if ($main_line =~ /<ul><!--insert: $last_message-->/) {
				print MAIN "<ul><!--insert: $last_message-->\n";
				print MAIN "<!--top: $num--><li><a href=\"$mesgdir/$num\.$ext\">$subject</a> - <b>";

				if ($use_rank == 1) {
					if ($rank ne '') {
						print MAIN "$ranktitle{$rank} ";
					}
					else {
						print MAIN "$civiliantitle ";
					}
				} # end of use_rank

				print MAIN "$name</b> ";

				if ($use_rank == 1) {
					if ($rank ne '') {
						print MAIN "<img src=\"$rankbadge{$rank}\" height=$badgeheight width=$badgewidth>";
					}
					else {
						# to be defined
					}
				} # end of use_rank

				if ($show_unix == 1) {
					if (($ENV{'HTTP_USER_AGENT'} =~ /nix/i) ||
					    ($ENV{'HTTP_USER_AGENT'} =~ /nux/i) ||
					    ($ENV{'HTTP_USER_AGENT'} =~ /lynx/i) ||
					    ($ENV{'HTTP_USER_AGENT'} =~ /X11/i) ||
					    ($rank eq $ranklist[0]) )
					{
						print MAIN "<img src=\"$unixbadge\" height=15 width=15> ";
					}
				}

				if ($use_DES == 1) {
					print MAIN " <i>$date</i> ($authnum)\n";
				}
				else {
					print MAIN " <i>$date</i>\n";
				}
				# we still need a line here for the splice stuff above (and in fd_admin.cgi)
				if ($show_respnum == 1) {
					print MAIN "(<!--responses: $num-->0)\n";
				}
				else {
					print MAIN "<!--responses: -->\n";
				}
				print MAIN "<ul><!--insert: $num-->\n";
				print MAIN "</ul><!--end: $num-->\n";
			}
			elsif ($main_line =~ /\(<!--responses: (\d+)-->(\d+)\)/) {
				$response_num = $1;
				$num_responses = $2;
				$num_responses++;
				foreach $followup_num (@followup_num) {
					if ($followup_num == $response_num) {
						print MAIN "(<!--responses: $followup_num-->$num_responses)\n";
						$work = 1;
						last;
					}
				}
				if ($work != 1) {
					print MAIN "$main_line";
				}
			}
			else {
				print MAIN "$main_line";
			}
		}
	}
	close(MAIN);

	# delete old message file (using $max_archive here, just in case !)
	if ($auto_cut == 1 && $num > $max_archive)
	{
		$cutfiles = ($num - $max_archive);
		$filename = "$basedir/$mesgdir/$cutfiles\.$ext";
		if (-e $filename) {
			unless (unlink("$filename")) {
				if ($log_errors == 1) {
					log_msg("Board Script Error : Can't delete old file $filename - $!\n");
				}
			}
		}
	}
}


###################################
# 15. Add Followup Threading to Individual Pages
#

sub thread_pages {
	foreach $followup_num (@followup_num) {
		# if we can't open the file, we just skip it here...
		open(FOLLOWUP,"+<$basedir/$mesgdir/$followup_num\.$ext") || next;
		flock(FOLLOWUP, $lock_ex) || show_die("Can't flock followup message $followup_num - $!\n");
		@followup_lines = <FOLLOWUP>;
		seek(FOLLOWUP,0,0);
		truncate(FOLLOWUP,0) || show_die("Can't truncate followup message $followup_num - $!\n");

		foreach $followup_line (@followup_lines) {
			$work = 0;
			if ($followup_line =~ /<ul><!--insert: $last_message-->/) {
				print FOLLOWUP "<ul><!--insert: $last_message-->\n";
				print FOLLOWUP "<!--top: $num--><li><a href=\"$num\.$ext\">$subject</a> ";
				if ($use_DES == 1) {
					# put DES at the end now...
					#print FOLLOWUP "- <b>$name</b> ($authnum) <i>$date</i>\n";
					print FOLLOWUP "- <b>$name</b> <i>$date</i> ($authnum)\n";
				}
				else {
					print FOLLOWUP "- <b>$name</b> <i>$date</i>\n";
				}
				if ($show_respnum == 1) {
					print FOLLOWUP "(<!--responses: $num-->0)\n";
				}
				else {
					print FOLLOWUP "<!--responses: -->\n";
				}
				print FOLLOWUP "<ul><!--insert: $num-->\n";
				print FOLLOWUP "</ul><!--end: $num-->\n";
			}
			elsif ($followup_line =~ /\(<!--responses: (\d+)-->(\d+)\)/) {
				$response_num = $1;
				$num_responses = $2;
				$num_responses++;
				foreach $followup_num (@followup_num) {
					if ($followup_num == $response_num) {
						print FOLLOWUP "(<!--responses: $followup_num-->$num_responses)\n";
						$work = 1;
						last;
					}
				}
				if ($work != 1) {
					print FOLLOWUP "$followup_line";
				}
			}
			else {
				print FOLLOWUP "$followup_line";
			}
		}
		close(FOLLOWUP);
	}
}


###################################
# 16. Return HTML page to browser
#

sub return_html {
	if ($use_DES == 1 || ($use_rank == 1 && $rank eq '')) {
		print_cookie('magic', $authnumraw, 365 * 24 * 3600);
	}
	&print_http;

	print <<EOT1;
<HTML>
<HEAD>
	<META HTTP-EQUIV ="Refresh" CONTENT = "2 ; URL=$baseurl/$mesgfile">
	<TITLE>Message Added: $subject</TITLE>
EOT1

	if ($use_DES == 1 && $cookie_printed == 0) {
		print <<EOT2;
<SCRIPT LANGUAGE="JavaScript">
<!--
 // save a cookie.
 function setCookie(name, value, expires) {
  document.cookie = name + "=" + escape(value) + "; path=/" + ((expires == null) ? "" : "; expires=" + expires.toGMTString());
 }
 var exp = new Date();
 exp.setTime(exp.getTime() + (1000 * 3600 * 24 * 365));
 setCookie("magic", "$authnumraw", exp);

// -->
</SCRIPT>
EOT2
	}


	print <<EOT3;
</HEAD>

$background
<CENTER><H1>Message Added: $subject</H1></CENTER>

Your message has been added. You are now returning to the <A HREF="$baseurl/$mesgfile">$title</A>.
<BR>
$page_bottom
EOT3

}

###################################
# Print HTTP Content-type header (only once !)
#

sub print_http {
	if ($http_printed == 0) {
		print "Content-type: text/html\n\n";
		$http_printed = 1;
	}
}

###################################
# Print some cookie (must be done before content-type !)
#
# Format = Set-Cookie: foo=bar; path=/; expires=Mon, 01-Jan-2001 00:00:00 GMT
# (expires is in seconds here, no multiple values allowed)

sub print_cookie {
	my($name,$value,$expires) = @_;

	$cookie_printed = 0;
	if ($http_printed == 1) {
		return;
	}

	$name =~ s/([^a-zA-Z0-9_.-])/uc sprintf("%%%02x",ord($1))/eg;
	$value =~ s/([^a-zA-Z0-9_.-])/uc sprintf("%%%02x",ord($1))/eg;

	my(@months) = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	my(@days) = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');

	my($now) = time;
	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime($now + $expires);
	$year += 1900;
	my($expdate) = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT", $days[$wday], $mday, $months[$mon], $year, $hour, $min, $sec);

	print "Set-Cookie: $name=$value; path=/; expires=$expdate\n";
	$cookie_printed = 1;
}

###################################
# a. Show script error message and die
#

sub show_die {
	my($msg) = @_;

	&print_http;

	print <<EOT;
<HTML>
<HEAD>
	<TITLE>$title BOARD SCRIPT ERROR</TITLE>
</HEAD>
$background
<CENTER><H1>BOARD SCRIPT ERROR</H1></CENTER>
The following error was encountered while processing your request :
 <P>
 <TABLE BORDER="1" CELLPADDING="5"><TR><TD>
 $msg
 </TD></TR></TABLE>
 <BR>
<B>Go back and try again</B>
<P>
Note : if this error persists, contact the $webmaster.
<P>
$page_bottom
EOT

	# Log the reason for dying
	if ($log_errors == 1) {
		log_msg("Board Script Error : $msg");
	}

	# Clear overload protection (if any)
	if ($limit_load > 0) {
		&clear_load;
	}

	# We stop here
	exit;
}


###################################
# b. Log script error messages
#

sub log_msg {
	my($msg) = @_;

	# we can't use show_die() here, of course
	if (open(LOG,">>$datadir/$logfile")) {
		print LOG "$$: $date - $msg";
		close(LOG);
	}
}


###################################
# c. Error Messages Subroutine
#

sub error {
	my($error) = @_;

	if ($error eq 'no_name') {
		&print_http;

		print "<html><head><title>$title ERROR: No Name</title></head>\n";
		print "$background<center><h1>ERROR: No Name</h1></center>\n";
		print "<br>You forgot to fill in the 'Name' field in your posting.  Go back and re-submit.  The necessary fields are: Name, Subject and Message.<p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}
	elsif ($error eq 'no_subject') {
		&print_http;

		print "<html><head><title>$title ERROR: No Subject</title></head>\n";
		print "$background<center><h1>ERROR: No Subject</h1></center>\n";
		print "<br>You forgot to fill in the 'Subject' field in your posting.  Go back and re-submit.  The necessary fields are: Name, Subject and Message.<p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}
	elsif ($error eq 'no_body') {
		&print_http;

		print "<html><head><title>$title ERROR: No Message</title></head>\n";
		print "$background<center><h1>ERROR: No Message</h1></center>\n";
		print "<br>You forgot to fill in the 'Message' fieldin your posting.  Go back and re-submit.  The necessary fields are: Name, Subject and Message.<p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}
	elsif ($error eq 'bad_words') {
		&print_http;

		print "<html><head><title>$title Lameness Protection Initiated</title></head>\n";
		print "$background<center><h1>ERROR: Lameness Warning!</h1></center>\n";
		print "<p>Our AI web board script has read your post and has decided that it may contain banned topics. The purpose of this board is for serious discussion. Your post may also contain a question that has already been addressed in our <a href=\"faq2.shtml\">Hack FAQ</a>. If this warning has been triggered by accident, please edit your post to remove any possible banned topics (for example, swearing) and re-send. Otherwise, post your message on <a href =\"http://www.cyberarmy.com/search/Discussion_Forums/Web_Boards/\">someone elses board</a>.\n";
		print "<p>If the script has misread your post, you can go back and try again. If you keep trying to post lame messages, we may steal your identity, cancel your credit cards, order you pizzas, etc. etc. etc.<p>\n";
		# show bad word again
		print "The lame topic you tried to post on was: <b>$thisisbad</b>.<P>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}
	elsif ($error eq 'board_bomb') {
		&print_http;

		print "<html><head><title>$title Bombing Protection Initiated</title></head>\n";
		print "$background<center><h1>ERROR: Bombing Protection Initiated</h1></center>\n";
		print "<br>Bombing the board, lamer? You have been LOGGED, and we will contact your ISP.<p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}
	elsif ($error eq 'test') {
		&print_http;

		print "<html><head><title>$title No Tests</title></head>\n";
		print "$background<center><h1>ERROR: No Test Messages</h1></center>\n";
		print "<br>Please, don't post 'test' messages on the board! I promise you, the board works fine!<p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}
	elsif ($error eq 'no_spam') {
		&print_http;

		print "<html><head><title>$title Spamming Protection Initiated</title></head>\n";
		print "$background<center><h1>ERROR: $spam_time Second Post Rule</h1></center>\n";
		print "<br>To prevent spam a $spam_time second posting rule has been implemented. Please try to post your message again in $spam_time seconds.<p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}
	elsif ($error eq 'aol') {
		&print_http;

		print "<html><head><title>$title AoL Ban</title></head>\n";
		print "$background<center><h1>ERROR: AoL Lamer</h1></center>\n";
		print "<br>Because 90% of people who post from AoL only cause problems here, you have been blocked at the source. Please try someone else's message board. There is no work-around.<p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}

	elsif ($error eq 'no_civilians') {
		&print_http;

		print "<html><head><title>$title Civilian Lockout</title></head>\n";
		print "$background<center><h1>ERROR: Civilian Lockout</h1></center>\n";
		print "<br>The board has temporarily been set so that only officers may start threads on this board.<p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}


	elsif ($error eq 'bad_headers') {
		&print_http;

		print "<HTML><HEAD><TITLE>$title Security Lockout</TITLE></HEAD>$background<br>\n";
		print "<p>&nbsp;</p><font face=\"arial\">\n";
		print "<center><H2>$title Security Lockout</H2></center><br>\n";
		print "<p>This script can only be called via browsers and proxies following the usual HTTP protocol, to help prevent people exploiting it. For some reason, the script has determined that it was not called from there. Occassionaly, it is mistaken. If you are not trying to hack us, you should retype $baseurl in your browser, reload the page, and try again. If that still doesnt work, contact the $webmaster. This error and your details have been logged.</p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}
	elsif ($error eq 'bad_referer') {
		&print_http;

		print "<HTML><HEAD><TITLE>$title Security Lockout</TITLE></HEAD>$background<br>\n";
		print "<p>&nbsp;</p><font face=\"arial\">\n";
		print "<center><H2>$title Security Lockout</H2></center><br>\n";
		print "<p>This script can only be called from $baseurl, to help prevent people exploiting it. For some reason, the script has determined that it was not called from there. Occassionaly, it is mistaken. If you are not trying to hack us, you should retype $baseurl in your browser, reload the page, and try again. If that still doesnt work, contact the $webmaster. This error and your details have been logged.</p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}

	elsif ($error eq 'no_cookie') {
		&print_http;

		print "<HTML><HEAD><TITLE>No Cookies</TITLE></HEAD>$background<br>\n";
		print "<p>&nbsp;</p><font face=\"arial\">\n";
		print "<center><H2>No Cookies</H2></center><br>\n";
		print "<p>You must have cookies enabled to post here. Check your browser options, and enable cookies.</p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}


	elsif ($error eq 'ban_user') {
		# set $user_ip to the IP of the person posting
		$user_ip = $ENV{'REMOTE_ADDR'};
		# set $work to 0
		$work = 0;
		# set $now to now
		$now = time;

		open(FILE,"+<$datadir/$ip_file") || show_die("Can't open ip ban file - $!\n");
		flock(FILE, $lock_ex) || show_die("Can't flock ip ban file - $!\n");
		@IP_lines = <FILE>;
		seek(FILE,0,0);
		truncate(FILE,0) || show_die("Can't truncate ip ban file - $!\n");

		foreach $ip_line (@IP_lines) {
			chomp($ip_line);
			($dtime,$dip) = split(/\t/,$ip_line);
			# regex here to allow subnet banning
			if ($user_ip =~ /^$dip/) {
				if ($dtime < 0) {
					print FILE "$ip_line\n";
				}
				elsif ($ban_time < 0) {
					print FILE "$ban_time\t$user_ip\n";
				}
				else {
					print FILE "$now\t$user_ip\n";
				}
				$work = 1;
				# don't bail out, we need to re-print the rest too
			}
			elsif ($dtime < 0 || $ban_time < 0 || $dtime + $ban_time >= $now) {
				print FILE "$ip_line\n";
			}
		}
		if ($work != 1) {
			if ($ban_time < 0) {
				print FILE "$ban_time\t$user_ip\n";
			}
			else {
				print FILE "$now\t$user_ip\n";
			}
		}
		close(FILE);

		# default 365 days
		if ($ban_time <= 0) {
			$exptime = 365 * 24 * 3600;
		}
		else {
			$exptime = $ban_time;
		}

		print_cookie('magic', 'rubberchicken', $exptime);
		&print_http;

		print <<EOT1;
<HTML>
<HEAD>
	<META HTTP-EQUIV ="Refresh" CONTENT = "2 ; URL=http://www.cyberarmy.com/crash.shtml">
	<TITLE>$title ERROR: You Have Been Banned</TITLE>
EOT1

		if ($cookie_printed == 0) {
			print <<EOT2;
<SCRIPT LANGUAGE="JavaScript">
<!--
 // save a cookie.
 function setCookie(name, value, expires) {
  document.cookie = name + "=" + escape(value) + "; path=/" + ((expires == null) ? "" : "; expires=" + expires.toGMTString());
 }
 var exp = new Date();
 exp.setTime(exp.getTime() + (1000 * $exptime));
 setCookie("magic", "rubberchicken", exp);

// -->
</SCRIPT>
EOT2
		}

		print <<EOT3;
</HEAD>

$background
<CENTER><H2>ERROR: ACCESS DENIED!<br><br>You've been BANNED!<br><br><br>
<br>You've just been banned for 3 days, starting now. Do not try to post within the next 3 days or the ban time will start again. Goodbye...</H2>
</CENTER>
<P>
$page_bottom
EOT3

	}
	else { # some other error message
		if ($log_warnings == 1) {
			log_msg("WARNING : unknown error $error for $host ($ENV{'REMOTE_ADDR'}) = $FORM{'name'} ($FORM{'magic'})\n");
		}

		&print_http;

		print "<html><head><title>$title Error</title></head>\n";
		print "$background<center><h1>$title Error</h1></center>\n";
		print "<br>You have generated the following error :<p>$error\n";
		print "<p>Go back and try again.<p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}

	# Clear overload protection (if any)
	if ($limit_load > 0) {
		&clear_load;
	}

	# We stop here
	exit;
}


###################################
# Anti-Overload Mod.2beta (cyberarmy)
#
# compensates for poor file locking on perl/Linux machines. (is that so ?)
# 2 protection modes. mode1 is a fast blocker. counts number of current req.
# if ne 1, overload error. mode2 is a persistent blocker. takes a while for
# the file to form, but will block any reqests from about 2-15 second.

###################################
#
# WARNING : THE FOLLOWING MOD CHANGES ARE UNTESTED !!!
# (I've just cleaned up the file locking mechanisms)
#
# overload1 = number of concurrent requests (well, almost)
# overload2 = time between starting requests
#
# Choose one or the other protection method
#
# overload2 is probably the cleanest one
#

sub check_load {

	if ($limit_load == 1) {
####### mode1 protection (number of concurrent requests)
		open(NUMBER,"+<$datadir/overload1") || show_die("Can't open overload1 - $!\n");
		flock(NUMBER, $lock_ex) || show_die("Can't flock overload1 - $!\n");
		$n = <NUMBER>;
		seek(NUMBER,0,0);

		if ($n =~ /(\d+)/) {
			$overloadnum = $1;
		}
		else {
			if ($log_errors == 1) {
				log_msg("Board Script Error : The overload1 number is messed up : '$n'\n");
			}
			$overloadnum = 0;
		}
		$overloadnum++; # increase counter

		truncate(NUMBER,0) || show_die("Can't truncate overload1 - $!\n");
		print NUMBER "$overloadnum";
		close NUMBER;

		# choose your own limit here (in number of requests)
		if ($overloadnum > $max_load1) { &load_error; }
######## end mode1
	}
	elsif ($limit_load == 2) {
######## mode2 protection (time between starting requests)
		$current_time = time();

		open(NUMBER,"+<$datadir/overload2") || show_die("Can't open overload2 - $!\n");
		flock(NUMBER, $lock_ex) || show_die("Can't flock overload2 - $!\n");
		$n = <NUMBER>;
		seek(NUMBER,0,0);

		if ($n =~ /(\d+)/) {
			$olast = $1;
		}
		else {
			if ($log_errors == 1) {
				log_msg("Board Script Error : The overload2 number is messed up : '$n'\n");
			}
			$olast = 0;
		}

		truncate(NUMBER,0) || show_die("Can't truncate overload2 - $!\n");
		print NUMBER "$current_time";
		close NUMBER;

		$timebetween = $current_time - $olast; # time between posts

		# choose your own limit here (in seconds between requests)
		if ($timebetween < $max_load2) { &load_error;  }
######## end mode 2
	}

}

sub clear_load {

	if ($limit_load == 1) {
####### mode1 protection (number of concurrent requests)
		open(NUMBER,"+<$datadir/overload1") || show_die("Can't open overload1 - $!\n");
		flock(NUMBER, $lock_ex) || show_die("Can't flock overload1 - $!\n");
		$n = <NUMBER>;
		seek(NUMBER,0,0);

		if ($n =~ /(\d+)/) {
			$overloadnum = $1;
		}
		else {
			if ($log_errors == 1) {
				log_msg("Board Script Error : The overload1 number is messed up : '$n'\n");
			}
			$overloadnum = 1;
		}
		$overloadnum--; # decrease counter
		if ($overloadnum < 0) {
			if ($log_errors == 1) {
				log_msg("Board Script Error : The overload1 number is invalid : $overloadnum\n");
			}
			$overloadnum = 0;
		}

		truncate(NUMBER,0) || show_die("Can't truncate overload1 - $!\n");
		print NUMBER "$overloadnum";
		close NUMBER;
######## end mode1
	}
	elsif ($limit_load == 2) {
######## mode2 protection (time between starting requests)
		# You might put the current time in overload2 again here,
		# but that wouldn't help for the requests that came between
		# check_load and clear_load anyway, so why bother...
######## end mode 2
	}

}

sub load_error {
	&print_http;

	print "<html><head><title>$title Overload Error</title></head>\n";
	print "$background<center><h1>ERROR: Overload</h1></center>\n";
	print "<br>The board scripts are being bombed or are dealing with another simultaneous post. Please try your post again in 10 seconds.<p>\n";
	print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
	print "$page_bottom\n";

	# don't add to the load by logging this :)
	#log_msg("OVERLOAD- overload error for $host ($ENV{'REMOTE_ADDR'}) = $FORM{'name'} ($FORM{'magic'})\n");

	# Clear overload protection (if any)
	if ($limit_load > 0) {
		&clear_load;
	}

	# We stop here
	exit;
}

#
###### end antioverload


##############################################################################
# *** Anonymous Proxy Ban mod ***   version B52                              #
# Anonymous Proxy Security Check subroutine - fuck with script kiddy heads   #
# Original concept and code by RSnake, but of course i had to overdo it - kw #
# Modified further by -complex, 'TheGame' and hacked to bits by TW           #
##############################################################################

############################
#
# Configuration variables
#
# (they are actually set above, but I copied them here
# for the complex (tm) explanation)
#

# $detect_proxy = 0;		# try to detect if a proxy is used (master switch for the proxy_mod)

# $proxy_file = "my_proxies";	# Chmod 666
				# This file is used collect remote addresses of anonymous proxies only!
				# If you add/change the 'check_proxy_env' you must be absolutely sure of the consequences!
				# It is needed for 'stealth' proxies that are undetectable.
				# (See definition below)
				# Stealth proxies may manage to slip passed the 'check_proxy_env' subroutine a few times... 
				# but it will slip up eventually and ban itself ;) This rule applies to all proxy servers..
				# that do not forward the client address (which may be fake! BTW)
				# so the admin may decide to turn off the $ban_proxy variable and allow 'stealth' proxies to post.
				# Keep in mind that the error message continues to collect proxy IP's.

# $check_proxy_env = 1;		# check for proxy in environment
# $ban_proxy_env = 0;		# ban most proxies right away (NOT recommended !)

# $check_proxy_file = 1;	# check for proxy in proxy_file
# $ban_proxy_file = 1;		# ban proxies in proxy_file
				# Activate proxy IP banning (proxies listed in $proxy_file) ban 'stealth' proxies that cannot be banned otherwise!
				# The $proxy_file is updated with proxies that change their settings, most proxies that do this, eventually slip up..
				# and end up in the $proxy_file so in effect, ban themselves ;)

# $check_proxy_anon = 1;	# check for anonymous proxy (and add to proxy_file)
# $ban_proxy_anon = 1;		# ban anonymous proxies
				# Activate proxy enviroment banning (attempts to detect if the poster is using an anonymous proxy)
				# Keep in mind that once this is activated it will start adding anonymous proxys remote address to the $proxy_file

# $check_ping = 0;		# check that forwarded IP addresses exist (if ban_proxy_anon is ON) - doesn't work for hosts behind firewalls !
# $check_cookie = 1;		# check that cookies are sent (if ban_proxy_anon is ON) - cookies & Javascript must be enabled for this !

# It is possible for users to spoof the HTTP_X_FORWARDED_FOR IP while using a anonymous proxy through programs like A4Proxy (http://www.inetprivacy.com/)
# This script as it is will only IP ban detected proxies that have no X_FORWARDED_FOR through the "error message subroutine". (see below)
# The reason I don't IP ban proxies that forward a false client IP is because they may be posting behind a firewall that does not return the ICMP packets.
# This may cause the IP banning of a non-anonymous proxy which we don't want to do.

sub do_proxy_mod {
	if ($check_proxy_env == 1) {
		&do_proxy_env;		# $ban_proxy_env decides if we do ban there, or just change the $environ
	}
	if ($check_proxy_file == 1) {
		&do_proxy_file;		# $ban_proxy_file decides if we do ban there, or just change the $environ
	}
	if ($check_proxy_anon == 1) {
		&do_proxy_anon;		# $ban_proxy_anon decides if we do ban there, or just ADD the address to the proxy_file
	}
}

sub do_proxy_env {
	$is_proxy = 0;
	if ( ($ENV{'HTTP_FORWARDED'}) ||
		($ENV{'HTTP_CLIENT_IP'}) ||
		($ENV{'HTTP_XROXY_CONNECTION'}) ||
		($ENV{'HTTP_XONNECTION'}) ||
		($ENV{'HTTP_SP_HOST'}) ||
		($ENV{'HTTP_SP_HTTPS'}) ||
		($ENV{'HTTP_TE'}) ||
		($ENV{'HTTP_X_FORWARDED_FOR'}) ||
		($ENV{'HTTP_CACHE_CONTROL'}) ||
		($ENV{'HTTP_PROXY_CONNECTION'}) ||
		($ENV{'HTTP_VIA'}) ||
		($ENV{'HTTP_USERAGENT_VIA'}) ||
		($ENV{'HTTP_CACHE_INFO'}) ||
		($host =~ /^.?http.?\./i) ||
		($host =~ /^.?firewall.?\./i) ||
		($host =~ /^.?mail.?\./i) ||
		($host =~ /^.?dns.?\./i ) ||
		($host =~ /^.?pop.?\./i ) ||
		($host =~ /^.?gate.?\./i ) ||
		($host =~ /^.?gateway.?\./i ) ||
		($host =~ /^.?gatekeeper.?\./i ) ||
		($host =~ /^.?www.?\./i ) ||
		($host =~ /firewall/i) ||
		($host =~ /roxy/i) ||
		($host =~ /smtp/i) ||
		($host =~ /pxy/i) ||
		($host =~ /cache/i))
	{

		$is_proxy = 1;
	}

	$port = $ENV{'REMOTE_PORT'}; # Not much use really

	if ($is_proxy == 1) {
		$x_ip = $ENV{'HTTP_X_FORWARDED_FOR'}; # Used in proxy error messages
		$via = $ENV{'HTTP_VIA'}; # Used in proxy error messages

		# only plain ASCII characters allowed here
		$x_ip =~ tr/\040-\176//cd;
		# sploit found by complex
		$x_ip =~ s/<[^>]*>/(CUT)/g;
		# remove some characters we don't want to see here
		$x_ip =~ tr/<>&"//d;
		$x_ip =~ s/\s+/ /g;
		# some arbitrary size limit
		if (length($x_ip) > 120)
		{
			$x_ip = substr($x_ip, 0, 120);
		}

		# only plain ASCII characters allowed here
		$via =~ tr/\040-\176//cd;
		# sploit found by complex
		$via =~ s/<[^>]*>/(CUT)/g;
		# remove some characters we don't want to see here
		$via =~ tr/<>&"//d;
		$via =~ s/\s+/ /g;
		# some arbitrary size limit
		if (length($via) > 150)
		{
			$via = substr($via, 0, 150);
		}

		# not recommended !
		if ($ban_proxy_env == 1) {
			if ($log_banned == 1) {
				log_msg("PROXY - Proxy $host ($ENV{'REMOTE_ADDR'}) banned for $x_ip = $FORM{'name'} ($FORM{'magic'})\n");
			}
			&proxy_error('any_proxy');
		}

		# don't mess up the environ if you're the boardmaster !
		if ($addr ne $your_ip) {
			# CHECK THIS IF YOU CHANGED THE $environ FORMAT IN get_host !
			if ($environ =~ /^from\s+/) {
				$environ =~ s/^from\s+//;
				$environ = "from $x_ip via proxy $environ";
			}
			else {
				$environ = "$x_ip via proxy $environ";
			}
		}

		# if you want some heavy duty banning, you could ban ALL access via detected proxies here...
	}
	else {
		$x_ip = ''; # Used in proxy error messages
		$via = ''; # Used in proxy error messages
	}
}

# adapted from check_ip - but different format !!!
# (you can add other HTTP headers etc. in the add_proxy() routine if you want)
###################################
# Proxy Ban Mod (Ken Williams) & complex
#
# Format adapted for logging of hostname and HTTP_VIA :
# XXX.XXX.XXX.XXX	thishost	Squid			(IP address banned)
# XXX.XXX.	thatnet	blabla					(subnet banned)
# XXX.XXX.XXX.XXX	stealthy	I don't trust it	(some presumed stealth proxy)
# etc.
#
# You can edit this proxy_file manually too if you want, but make sure you use TABs between each field !
#

sub do_proxy_file {
	# set $user_ip to the IP of the presumed proxy
	$user_ip = $ENV{'REMOTE_ADDR'};
	# set $ok to 1
	$ok=1;

	# open for read/write to allow flock to work on most platforms, even those with lockf(3)
	open(FILE,"+<$datadir/$proxy_file") || show_die("Can't open proxy file - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock proxy file - $!\n");
	@IP_lines = <FILE>;
	close(FILE);

	foreach $ip_line (@IP_lines) {
		chomp($ip_line);
		# add your own fields here - see proxy_error('proxy')
		($dip,$dhost,$dvia) = split(/\t/,$ip_line);
		# regex here to allow subnet banning
		if ($user_ip =~ /^$dip/) {
			$ok = 0;
			# bail out, we've seen enough
			last;
		}
	}

	# if this IP is already in the proxy_file
	if ($ok == 0)
	{
		if ($ban_proxy_file == 1) {
			if ($log_banned == 1) {
				log_msg("PROXY - Banned Proxy $host ($ENV{'REMOTE_ADDR'}) found for $x_ip = $FORM{'name'} ($FORM{'magic'})\n");
			}
			&proxy_error('banned_proxy');
		}
		elsif ($is_proxy == 0) { # i.e. NOT detected before in do_proxy_env
			# don't mess up the environ if you're the boardmaster !
			if ($addr ne $your_ip) {
				# CHECK THIS IF YOU CHANGED THE $environ FORMAT IN get_host !
				if ($environ =~ /^from\s+/) {
					$environ =~ s/^from\s+//;
					$environ = "from $x_ip via proxy $environ";
				}
				else {
					$environ = "$x_ip via proxy $environ";
				}
			}
		}
		else { # since we already know this proxy, clear $is_proxy here, so that do_proxy_anon won't ban this again (and again, and again, ...)
			$is_proxy = 0;
		}
	}
}

sub do_proxy_anon {

	# Don't check twice...
	if ($is_proxy == 0) {
		return;
	}

	# Assuming X_FORWARDED_FOR can look like this : xxx.xxx.xxx.xxx,unknown,xxx.xxx.xxx.xxx

	# Decide under what conditions to ban (this is the key to it all, lots of room for improvment here)
	# Note : this is the ONLY place where proxies are ADDED to the $proxy_file !
	if (	($x_ip eq "") ||
		($x_ip =~ /127\.0\.0\.1/) || # stop the server pinging itself
		($x_ip =~ /$addr/o) ||
		($ENV{'REMOTE_HOST'} ne '' && $x_ip =~ /$ENV{'REMOTE_HOST'}/o)) # check REMOTE_HOST here, not hostname !?!
	{
		# this is the ONLY place where proxies are ADDED to the $proxy_file !
		&add_proxy;

		if ($ban_proxy_anon == 1) {
			if ($log_banned == 1) {
				log_msg("PROXY - Proxy $host ($ENV{'REMOTE_ADDR'}) banned for invalid address $x_ip = $FORM{'name'} ($FORM{'magic'})\n");
			}
			&proxy_error('anon_proxy');
		}
	}

	# Don't bother with the rest if ban_proxy_anon is OFF ?!?
	if ($ban_proxy_anon == 0) {
		return;
	}

	# Here, we won't add to the proxy file (yet)

	@iplist = split(/,/,$x_ip);
	foreach $ip (@iplist) {
		if ($ip =~ /(\d+\.\d+\.\d+\.\d+)/) {
			push(@checklist, $1);
		}
		else {
			# bail out in case of invalid X_FORWARDED_FOR value ?
			if ($log_warnings == 1) {
				log_msg("PROXY - Invalid IP $x_ip via proxy $host ($ENV{'REMOTE_ADDR'}) = $FORM{'name'} ($FORM{'magic'})\n");
			}
			&proxy_error('bad_ip');
			last;
		}
	}

	if ($check_ping == 1) {
		$ok = 1; # default = OK :)

		eval { # try using standard Net::Ping module in ICMP mode
			require Net::Ping;
			$p = Net::Ping->new("icmp"); # you may need to be root for this, or setuid your script !
			#foreach $check (@checklist) {
		# check only the first IP address !?!
			$check = $checklist[0];
				unless ($p->ping($check, 2)) {
					$ok = 0;
				#	last;
				}
			#}
			$p->close();
			1; # make sure eval returns OK
		}
		|| eval { # try using system call to ping (-c is not known on all Unix platforms !)
			#foreach $check (@checklist) {
		# check only the first IP address !?!
			$check = $checklist[0];
				$p1 = `ping -c 1 $check| grep time`;
				$pingtime = substr($p1, 5, 100); # http://www.perlreference.com/perldoc//lib/Net/Ping.html (?)
				unless ($pingtime) {
					$ok = 0;
				#	last;
				}
			#}
			1; # make sure eval returns OK
		}
		|| eval { # this basically means that you can't test for ping on your server !
			log_msg("PROXY - Unable to perform PING here !\nError message from system : '$@'\nPlease set your \$check_ping variable to OFF !!!\n");
		};

		if ($ok == 0) {
			if ($log_warnings == 1) {
				log_msg("PROXY - No ping for $x_ip via proxy $host ($ENV{'REMOTE_ADDR'}) = $FORM{'name'} ($FORM{'magic'})\n");
			}
			&proxy_error('no_ping');
		}
	}

	# I decided to force the user to use cookies, this helps to ban proxies that block cookies
	if ($check_cookie == 1) {
		if (!$ENV{'HTTP_COOKIE'}) {
			if ($log_warnings == 1) {
				log_msg("PROXY - No cookies for $x_ip via proxy $host ($ENV{'REMOTE_ADDR'}) = $FORM{'name'} ($FORM{'magic'})\n");
			}
			&proxy_error('no_cookie');
		}
	}
}

sub add_proxy {
	open(FILE,">>$datadir/$proxy_file") || show_die("Can't open proxy ban file - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock proxy ban file - $!\n");
	# add your own favourite variables here for safe-keeping...
	print FILE "$ENV{'REMOTE_ADDR'}\t$host\t$ENV{'HTTP_VIA'}\n";
	close(FILE);

	open(LOG,">>$datadir/$logfile") || show_die("Can't open log file - $!\n");
	# Locking is not really necessary, but it should reduce the risk of having log
	# entries interleaved with others...
	flock(LOG, $lock_ex) || show_die("Can't flock log file - $!\n");

	print LOG "$$: <------- Proxy $host ($addr) HAS BEEN BANNED----->\n";
	# full logging (just in case this wasn't done before)
	# + identify each unique request with the process ID ($$)
	print LOG "$$: Environment variables - $date :\n";
	# print CONTENT_*, HTTP_*, QUERY_*, REMOTE_*, REQUEST_*
	foreach $key (sort keys %ENV) {
		if ($key =~ /^[CHQR]/) {
			print LOG "$$: $key = $ENV{$key}\n";
		}
	}
	print LOG "\n";
	close LOG;
}

# removed some complex-specific lines from the output here

sub proxy_error {
	my($error) = @_;

	if ($error eq 'any_proxy') {
		&print_http;

		print "<html><head><title>$title Proxy Lockout $x_ip</title></head>\n";
		print "$background\n";
		print "<h2 align=\"center\">ERROR: Proxy Lockout Initiated</h2>\n";
		print "<p align=\"center\"><br>\n";
		print "<strong>Host $host:$port ($addr) $via has been blocked!</strong>\n";
		print "<br><br>For security reasons the use of *most* Proxy Servers have been banned from posting on this board.\n";
		print "<br>If you need to access the board through a Proxy, please send your request to the $webmaster\n";
		print "<br>We apologise for any inconvenience this may have caused.</p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}
	elsif ($error eq 'banned_proxy') {
		&print_http;

		print "<html><head><title>$title Anonymous Proxy Lockout $x_ip</title></head>\n";
		print "$background\n";
		print "<h2 align=\"center\">ERROR: Anonymous Proxy Lockout Initiated</h2>\n";
		print "<p align=\"center\"><br>\n";
		print "<strong>Host $host:$port ($addr) $via has been blocked!</strong>\n";
		print "<br><br>For security reasons the Anonymous Proxy Server you are using has been banned from posting on this board.\n";
		print "<br>If you need to access the board through an Anonymous Proxy, please send your request to the $webmaster\n";
		print "<br>We apologise for any inconvenience this may have caused.</p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}
	elsif ($error eq 'anon_proxy') {
		&print_http;

		print "<html><head><title>$title Anonymous Proxy Lockout $x_ip</title></head>\n";
		print "$background\n";
		print "<h2 align=\"center\">ERROR: Anonymous Proxy Lockout Initiated</h2>\n";
		print "<p align=\"center\"><br>\n";
		print "<strong>Host $host:$port ($addr) $via has been blocked!</strong>\n";
		print "<br><br>For security reasons the use of *most* Anonymous Proxy Servers have been banned from posting on this board.\n";
		print "<br>If you need to access the board through an Anonymous Proxy, please send your request to the $webmaster\n";
		print "<br>We apologise for any inconvenience this may have caused.</p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}
	elsif ($error eq 'bad_ip') {
		&print_http;

		print "<html><head><title>$title Proxy Lockout $x_ip</title></head>\n";
		print "$background\n";
		print "<h2 align=\"center\">ERROR: Proxy Lockout Initiated</h2>\n";
		print "<p align=\"center\"><br>\n";
		print "<strong>Host $host:$port ($addr) $via has been blocked!</strong>\n";
		print "<br><br>For some reason, the Proxy Server you are using has forwarded an incorrect client IP address.($x_ip)\n";
		print "<br>We apologise for any inconvenience this may have caused.</p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}
	elsif ($error eq 'no_ping') {
		&print_http;

		print "<html><head><title>$title Proxy Lockout $x_ip</title></head>\n";
		print "$background\n";
		print "<h2 align=\"center\">ERROR: Proxy Lockout Initiated</h2>\n";
		print "<p align=\"center\"><br>\n";
		print "<strong>Host $host:$port ($addr) $via has been blocked!</strong>\n";
		print "<br><br>For some reason, the Proxy Server you are using has forwarded an invalid client IP address.($x_ip)\n";
		print "<br>Or you are trying to post this board via a Proxy Server behind a firewall.\n";
		print "<br>We apologise for any inconvenience this may have caused.</p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}
	elsif ($error eq 'no_cookie') {
		&print_http;

		print "<html><head><title>$title Proxy Lockout $x_ip</title></head>\n";
		print "$background\n";
		print "<h2 align=\"center\">ERROR: Lockout Initiated</h2>\n";
		print "<p align=\"center\"><br>\n";
		print "<strong>Host $host:$port ($addr) $via has been blocked!</strong>\n";
		print "<br><br>Your browser or host is not sending the required infomation to this server. ($host)\n";
		print "<br>Please check to see that your browser has cookies & Java Script enabled, and your host isn't an Anonymous Proxy Sever.\n";
		print "<br>Your host is blocked for lack of information!\n";
		print "<br>We apologise for any inconvenience this may have caused.</p>\n";
		print "<br>If you need to access the board through an Anonymous Proxy, please send your request to the $webmaster<P>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}
	else {
		if ($log_warnings == 1) {
			log_msg("WARNING : unknown proxy error $error for $host ($ENV{'REMOTE_ADDR'}) = $FORM{'name'} ($FORM{'magic'})\n");
		}

		&print_http;

		print "<html><head><title>$title Proxy Error</title></head>\n";
		print "$background<center><h1>$title Proxy Error</h1></center>\n";
		print "<br>You have generated the following proxy error :<p>$error\n";
		print "<p>Go back and try again.<p>\n";
		print "[ <a href=\"$baseurl/$mesgfile\">Return to the $title</a> ]<P>\n";
		print "$page_bottom\n";
	}

	# Clear overload protection (if any)
	if ($limit_load > 0) {
		&clear_load;
	}

	# We stop here
	exit;
}

###################################
#
# Database Authentication Mod (TheGame)
#

sub get_user {

	## cookies are already set in parse_form() here !
	#get_cookies();

	## get the key from the cookie
	if (!defined($cookie{'key'}) || length($cookie{'key'}) != 24) {
		do_civilians();
		return;
	}
	my $key = $cookie{'key'};

	## Get the user information from the User DB (use $userinfo{'name'} in script)
	get_userinfo($key);

	# check if we have a name that goes with that key
	if (!defined($userinfo{'name'}) || length($userinfo{'name'}) == 0) {
		do_civilians();
		return;
	}

	if (length($ENV{'REMOTE_USER'}) > 0 && $userinfo{'name'} ne $ENV{'REMOTE_USER'}) {
		show_die("Your cookie doesn't match your authenticated username - please authenticate yourself correctly...");
	}

	# always use registered name (for now)
	$name = escapeHTML($userinfo{'name'});

	# check if the user is (still) banned in the database
	# TODO - synchronize ban times
	if (defined($userinfo{'bantime'}) && $userinfo{'bantime'} > time) {
		error('ban_user');
	}

	# always use registered rank (for now)
	$groups = escapeHTML($userinfo{'groups'});

	$rank = '';
	foreach $try (@ranklist) {
		if (index($groups,$try) > -1) {
			$rank = $try;
			last;
		}
	}
	if ($rank eq '') {
		do_civilians();
		return;
	}

	if ($FORM{'showemail'} eq 'on') {
		# always use registered email (for now)
		$email = escapeHTML($userinfo{'email'});
	}

	if ($FORM{'showimg'} eq 'on') {
		# allow user to post specific img for this message
		if ( (length($message_img) == 0) && (length($userinfo{'img'}) > 0) ) {
			$message_img = 'http://' . escapeHTML($userinfo{'img'});
		}
	}

	if ($FORM{'showurl'} eq 'on') {
		# allow user to post specific url for this message
		if ( (length($message_url) == 0) && (length($userinfo{'url'}) > 0) ) {
			$message_url = 'http://' . escapeHTML($userinfo{'url'});
		}
		# allow user to post specific url_title for this message
		if ( (length($message_url_title) == 0) && (length($userinfo{'url_title'}) > 0) ) {
			$message_url_title = escapeHTML($userinfo{'url_title'});
		}
	}

}

sub do_civilians {
	if ($allow_civilians == 0) {
		error('no_civilians');
	}

#	$name = $authnum;	# use DES sig here for the moment :)
	if ($name eq '') {
		error('no_name');
	}

	$rank = '';
	$use_DES = 1; # switch on DES auth
}


############################################################################
#
# Some generic routines for the database authentication
#

## Get the user information from the User DB (use $userinfo{'name'} in script)

sub get_userinfo {
	my($userkey) = @_;

	# open for read/write to allow flock to work on most platforms, even those with lockf(3)
	open(FILE,"+<$user_db") || show_die("Can't open user database - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock user database - $!\n");
	chomp(@lines = <FILE>);
	close(FILE);

	foreach $line (@lines) {
		my ($name,$cryptpass,$groups,$key,$email,$img,$url_title,$url,$bantime,$etc) = split(/\:/, $line);
		if ($userkey eq $key) {
			$userinfo{'name'} = $name;
			$userinfo{'cryptpass'} = $cryptpass;
			$userinfo{'groups'} = $groups;
			$userinfo{'key'} = $key;
			$userinfo{'email'} = $email;
			$userinfo{'img'} = $img;
			$userinfo{'url_title'} = $url_title;
			$userinfo{'url'} = $url;
			$userinfo{'bantime'} = $bantime;
			$userinfo{'etc'} = $etc;
			last;
		}
	}
}

## Make string safe for HTML output (use $var = escapeHTML($var); in script)

sub escapeHTML {
	my($string) = @_;

	$string =~ s/&/&amp;/g;
	$string =~ s/"/&quot;/g;
	$string =~ s/</&lt;/g;
	$string =~ s/>/&gt;/g;

	return $string;
}

