#!/usr/local/bin/perl
#
####################################################################
# find.cgi  Search WWWBoard Articles
# Created by Craig Horton       (chorton@dbasic.com)
# Contributions by Matt Wright  (mattw@misha.net)
# Created on:  5/4/96
# I can be reached at:          dbasics@getscript.com
# Script Found at:              http://www.getscripts.com/
# This script may be redistributed for non-commericial reasons
# as long as this header remains intact. All copyrights reserved.
####################################################################
#
# 1.70a - 25/01/2000 :
# - revised directory and file search
# - improved display of messages
# - adapted to format of message files
# - added error logging
# - added experimental 'depth' option
#
# 1.70b - 30/01/2000 :
#
# 1.70c - 08/02/2000 :
# - search only in the message part of the files (to be improved)
#
# 1.70d - 12/02/2000 : (= release version 1.80)
#
# 1.70e - 14/02/2000 :
# - added size limit to form values
#
# 1.83a - 21/08/2000 :
# - moved $logfile to $datadir too
#
# TODO :
# - improve search criteria
# - show threaded results
# - improve search speed (incremental indexing ?)
# - add overload check (maybe more load generated here than for a message post !)
#
####################################################################


# You could copy the whole VARIABLES part from fd_board.cgi if you like,
# but you HAVE to check these specific Search variables.

    ########################
    # Specific Search variables
    #
	$search_url = "http://www.yoursite.com/cgi-bin/fd_find.cgi"; # URL where this fd_find.cgi script is
	$searchlimit = 40;		# maximum number of matches allowed

	$showdepth = 1;			# show depth of message according to followups
					# Someday, we could replace this with real threading...


##########################################
# VARIABLES - You must edit at least the
# 'File Locations' section to setup board.
#

    ########################
    # File Locations
    #

	$basedir = "/full_path/to/wwwboard";  # real path where your board dir is (your FTP client usually shows the real path)
	$baseurl = "http://www.yoursite.com/wwwboard";  # URL of your board dir
	@referers = ('www.yoursite.com', 'yoursite.com'); # base domain name where your site is

	$datadir = "/full_path/to/data_dir";  # real path where the config files are located (your FTP client usually shows the real path)

	$logfile = "my_log";		# Change this for some privacy !

    # Done! - thats all you *need* to edit. now just chmod everything, (incl. the 'messages'
    # directory) to 777, and the .cgi scripts to 755. then, tweak the stuff below to how you want.
    ###########

	$mesgfile = "index.html";	# It might be better security if you change them,
	$mesgdir = "messages";		# but not really needed.
	$ext = "html";			# Change to "shtml" if you want SSI. If you dont know what Im talking about, leave this as html


    ############################
    # Look / Feel Variables
    #
    # Note : if you have some SSI headers and/or footers (e.g. for banners),
    #        just add them here
    #

	$title = "Discussion Forum";	# Title of the board


	# This html will go at the TOP of every page (all error pages, message posts, etc.)
	# It's regular HTML code that you can cut and paste from an existing page.

	$background = <<'EOBackground';
<!-- start copy & paste background from your index.html -->

 <BODY BGCOLOR="#336699" TEXT="#FFFFFF" LINK="#FFFFFF" VLINK="#C0C0C0" ALINK="#C0C0C0">
 <FONT FACE="arial">

<!-- end copy & paste background from your index.html -->
EOBackground

# don't delete or change the 2 lines that say "EOBackground" - that means no spaces, no tabs, etc. !


	# This html will go at the BOTTOM of every page (all error pages, message posts, etc.)
	# It's regular HTML code that you can cut and paste from an existing page.

	$page_bottom = <<'EOPageBottom';
<!-- start copy & paste page_bottom from your index.html -->

 <BR>
 <SMALL>
 This board is powered by the <A HREF="http://www.cyberarmy.com/search/Programming/Releases/CyberArmy/Mr_Fong_Device">Mr. Fong Device</A> from Cyberarmy.com
 </SMALL>
 <BR>

<!-- end copy & paste page_bottom from your index.html -->
</BODY>
</HTML>
EOPageBottom
# don't delete or change the 2 lines that say "EOPageBottom" - that means no spaces, no tabs, etc. !


    ###################################
    # Security Variables (1=ON, 0=OFF)
    # 

	$log_errors = 1;		# log any script errors - you should leave this ON (and check your logfile from time to time !)
	$log_warnings = 1;		# log any warnings that people receive - this may be useful when you start a new board

#
# Nothing (necessary) to edit Past This Point
# A few things for advanced users only.
##############################################


###################################
# Main Script
#

# Remove output buffering
$|=1;

# Print out the content-type
print "Content-type: text/html\n\n";

# Check the referrer
&check_ref;

# Get the input
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);

	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

	if (length($value) > 120) {
		$value = substr($value,0,120);
	}
	$FORM{$name} = $value;
}

$query = $FORM{'query'};
$query =~ s/&/&amp;/g;
$query =~ s/"/&quot;/g;
$query =~ s/</&lt;/g;
$query =~ s/>/&gt;/g;

# Test validity of regex (e.g. problem with '?')
# Note : an alternative is to escape all special characters -> no regex

eval {
	if ("x" =~ /$FORM{'query'}/) {
	}
};
if ($@) {
	show_die("Invalid regular expression '$query'\n");
}

# Grab all files from the message directory
opendir(DIR,"$basedir/$mesgdir") || show_die("Can't open message directory - $!\n");
@files = readdir(DIR);
closedir(DIR);

print <<EOT;
 <HTML>
 <HEAD>
 	<TITLE>$title - Simple Search</TITLE>
 </HEAD>
 $background
 <H2><center>Search Results for '$query'</center></H2>
 <HR>
 <center>[ <a href="$baseurl/$mesgfile">Return to the $title</a> ]</center>
 <font face="arial" size="2">
 <OL>
EOT

# Find all nnnn.ext files and load message numbers into @FILES
foreach $file (@files) {
	if (-f "$basedir/$mesgdir/$file" && $file =~ /^(\d+)\.$ext$/) {
		push(@FILES, "$1");
	}
}

$count = 0;
# Search through message files by number - most recent first
foreach $num (sort {$b <=> $a} @FILES) {
	open(FILE,"<$basedir/$mesgdir/$num.$ext") || next; # just skip the file if we can't open it
	# we don't lock here either - if the file is incomplete, too bad...
	@LINES = <FILE>;
	close(FILE);
	$url = '';
	$name = '';
	$subject = '';
	$date = '';
	$followup = '';
	$skip = 1;
	$found = 0;
	foreach $line (@LINES) {
		if ($line =~ /<body/i) {
			$skip = 0;
			next;
		}
		# not interested in the part above the <body> tag
		if ($skip == 1) {
			next;
		}
		elsif ($found == 0) {
			if ($line =~ /<a name="followups">/i) {
				last;	# still found nothing here ? --> bail out !
			}
			elsif ($line =~ /$FORM{'query'}/io) {	# this should be improved...
				$url = "$baseurl/$mesgdir/$num.$ext";
				$found = 1;
			}
			next;
		}
		# We found something --> extract hidden field information
		if ($line =~ m#name="followup"\s+value="([^"]*)"#i) {
			$followup = $1;
		}
		elsif ($line =~ m#name="origname"\s+value="([^"]*)"#i) {
			$name = $1;
		# try to remove the environ string - YOU MAY HAVE TO CHANGE THIS !
			$name =~ s/\s+\[.*$//;
			$name =~ s/\s+from.*$//;
			$name =~ s/\s+\(.*$//;
		}
		elsif ($line =~ m#name="origsubject"\s+value="([^"]*)"#i) {
			$subject = $1;
		}
		elsif ($line =~ m#name="origdate"\s+value="([^"]*)"#i) {
			$date = $1;
			last;	# last field we're looking for here --> bail out !
		}
	}
	if ($found == 1) {
		# Show some real threads in the future ?
		if ($showdepth == 1 && $followup ne '') {
			@followuplist = split(/,/,$followup);
			$level = $#followuplist;
			print "  <LI>", '+' x $level, "<a href=\"$url\">$subject</A> - <b>$name</b> <i>$date</i>\n";
		}
		else {
			print "  <LI><a href=\"$url\">$subject</A> - <b>$name</b> <i>$date</i>\n";
		}
		$count++;
		if ($count >= $searchlimit) {
			print " <P>[ Search results limited to $searchlimit messages ]\n";
			last;
		}
	}
}

print "  </OL></font>\n";

if ($count == 0) {
	print " <CENTER>There are no messages matching your query...</CENTER>\n";
}

print <<EOT;
 <p>
 <form method=POST action="$search_url">
 <center>
 <b>Search the Archive</b>
 <p>
 <input type=text name="query" size=20>
 <input type=submit value="search">
 </center>
 </form>
 <BR>
 <center>[ <a href="$baseurl/$mesgfile">Return to the $title</a> ]</center>
 $page_bottom
EOT

exit;

#
# End of Main Script
###################################

###################################
# Check referrer (and user agent)
#

sub check_ref {
	$requrl = $ENV{'HTTP_REFERER'};
	$flag = 0;

	if ((!$ENV{'HTTP_REFERER'}) || (!$ENV{'HTTP_USER_AGENT'})) {
		$flag=0;
	}
	else {
		foreach $each (@referers){
			if ($requrl =~ /$each/i){
				$flag=1;
				last;
			}
		}
	}
	if ($flag == 1) {
		return;
	}

	print <<EOT;
 <HTML>
 <HEAD>
 	<TITLE>$title Search - Security Lockout</TITLE>
 </HEAD>
 $background
 <center><H2>$title Search - Security Lockout</H2></center>
 <br><p>
 This script can only be called from <B>$baseurl</B>, to help prevent people exploiting it.
 For some reason, the script has determined that it was not called from there.
 Occassionaly, it is mistaken. If you are not trying to hack us, you should retype
 the URL in your browser, reload the page, and try again.
 <BR>
 If that still doesn't work, contact the webmaster.
 <P>
 This error and your details have been logged.
 <p>
 <center>[ <a href="$baseurl/$mesgfile">Return to the $title</a> ]</center>
 $page_bottom
EOT

	if ($log_warnings == 1) {
		log_msg("WARNING : Search Security Lockout - wrong referrer '$ENV{'HTTP_REFERER'}' or missing user agent...\n");
	}

	exit;
}

###################################
# a. Show script error message and die
#

sub show_die {
	my($msg) = @_;

	print <<EOT;
 <HTML>
 <HEAD>
 	<TITLE>$title - SEARCH SCRIPT ERROR</TITLE>
 </HEAD>
 $background
 <CENTER>
 <H2>SEARCH SCRIPT ERROR</H2>
 <HR>
 The following error was encountered while processing your request :
 <P>
 <TABLE BORDER="1" CELLPADDING="5"><TR><TD>
 $msg
 </TD></TR></TABLE>
 <BR>
 <B>Go <a href="$baseurl/$mesgfile">back</A> and try again</B>
 <P>
 Note : if this error persists, contact the webmaster.
 <P>
 </CENTER>
 $page_bottom
EOT

	# Log the reason for dying
	if ($log_errors == 1) {
		log_msg("Search Script Error : $msg");
	}

	# We stop here
	exit;
}


###################################
# b. Log script error messages
#

sub log_msg {
	my($msg) = @_;

	# we can't use show_die() here, of course
	if (open(LOG,">>$datadir/$logfile")) {
		$date = scalar localtime; # no get_time routine here
		print LOG "$date - $ENV{'REMOTE_ADDR'} - $msg";
		close(LOG);
	}
}

